package com.bonait.bnframework.HBL;

import com.bonait.bnframework.common.helper.MessageLog;
import com.bonait.bnframework.common.helper.SendData;
import com.google.gson.Gson;
import com.lzy.okgo.model.HttpParams;

import java.util.Map;

import fi.iki.elonen.NanoHTTPD;

public class HttpServer extends NanoHTTPD {
    public HttpServer() {
        super(35000);
        try{
            start(NanoHTTPD.SOCKET_READ_TIMEOUT, false);
        }catch  (Exception ex){
            MessageLog.ShowError("启动服务失败!"+ex.getMessage());
        }
    }
    @Override
    public Response serve(IHTTPSession session) {
        try{
            if (session.getMethod()==Method.POST){
                Map<String,String> headers= session.getHeaders();//获取请求头数据
                if(session.getUri().contains("/api/GetMainConsoleData")){
                    return newFixedLengthResponse(Response.Status.OK, HttpParams.MEDIA_TYPE_JSON.toString(), new Gson().toJson( new SendData())); // 返回响应
                }
            }
            return newFixedLengthResponse(Response.Status.INTERNAL_ERROR, HttpParams.MEDIA_TYPE_JSON.toString(), new Gson().toJson("不是有效的请求")); // 返回响应
        }catch (Exception ex){
            MessageLog.ShowError("请求失败！"+ex.getMessage());
            return newFixedLengthResponse(Response.Status.INTERNAL_ERROR, HttpParams.MEDIA_TYPE_JSON.toString(), new Gson().toJson(ex.getMessage())); // 返回响应
        }
    }
}
