package com.bonait.bnframework.business;

import android.util.Log;

import com.bonait.bnframework.common.db.res.UserLogEnum;
import com.bonait.bnframework.common.helper.MessageLog;
import com.bonait.bnframework.common.utils.ToastUtils;

/**
 * 一拖二设备控制
 */
public class DoubleFryingpanControl extends ControlBase {
    private static DoubleFryingpanControl mInstance; //实例变量设置私有，防止直接通过类名访问

    public static synchronized DoubleFryingpanControl getInstance() { //静态同步方法作为唯一的实例对象获取方式
        if (mInstance == null) {
            mInstance = new DoubleFryingpanControl();
        }
        return mInstance;
    }

    private DoubleFryingpanControl() {

    }

    @Override
    public  void RobotDataListen()throws InterruptedException{
        //机器人急停
//        RobotModbus.getInstance().ReadBool("M640",1,1, value->{
//            for (int i =0;i<4;i++){
//                MbSlave.WriteBoolean(GetAddress(i+1,AddressData.EStop),value[0]);
//            }
//        });

        //机器人入库完成
        RobotModbus.getInstance().ReadBool(RobotAddress("M620"),6,1,value->{
            RobotData.RobotWarehousingComplete=value;
        });

        //指定位置有盆
        RobotModbus.getInstance().ReadBool(RobotAddress("M630"),4,1,value->{
            RobotData.WarehouseLocHavingBasin=value;
        });

        //机器人到达维护位
        RobotModbus.getInstance().ReadBool(RobotAddress("M640"),1,1,value->{
            RobotData.RobotReachTending=value[0];
        });

        //机器人状态
        RobotModbus.getInstance().ReadBool(RobotAddress("M650"),4,1,value->{
            RobotData.RobotHome=value[0];//机器人原点位
            RobotData.RobotReady=value[1];//机器人准备就绪
            RobotData.EStop.setValue(value[2]);//机器人急停
            RobotData.Grating.setValue(value[3]);//机器人光栅
        });

        //机器人准备就绪
//        RobotModbus.getInstance().ReadBool(RobotAddress("M651"),1,1,value->{
//            RobotData.RobotReady=value[0];
//        });

        //机器人任务反馈
        RobotModbus.getInstance().ReadShort("GI5",1,1,value->{
            RobotData.RobotTaskFeedback=value[0];
        });

        //机器人1号炒锅完成
        RobotModbus.getInstance().ReadBool(RobotAddress("M600"),4,1,value->{
            RobotData.FryingStatus.get(1).PutMaterialComplete=value[0];
            RobotData.FryingStatus.get(1).FallSeasoningComplete=value[1];
            RobotData.FryingStatus.get(1).RequestDiningOut=value[2];
            RobotData.FryingStatus.get(1).DiningOutComplete=value[3];
        });

        //机器人2号炒锅完成
        RobotModbus.getInstance().ReadBool(RobotAddress("M610"),4,1,value->{
            RobotData.FryingStatus.get(2).PutMaterialComplete=value[0];
            RobotData.FryingStatus.get(2).FallSeasoningComplete=value[1];
            RobotData.FryingStatus.get(2).RequestDiningOut=value[2];
            RobotData.FryingStatus.get(2).DiningOutComplete=value[3];
        });

        RobotData.RobotIdle=RobotData.RobotHome&&RobotData.RobotTaskFeedback==0;//机器人空闲状态

        String str1 = MbSlave.ReadString(GetSiloAdd(1));
        RobotData.Fryingpan1.setValue(str1);
//        RobotData.SiloMaterial.put(1,str1);

        String str2 =  MbSlave.ReadString(GetSiloAdd(2));
        RobotData.Fryingpan2.setValue(str2);
//        RobotData.SiloMaterial.put(2,str2);

//        RobotData.RobotIdle=true;//机器人空闲状态

//        for(int i=1;i<=2;i++){
//          if(!ForceEnd[i-1]&& MbSlave.ReadBoolean(GetAddress(i,AddressData.FryingpanForceEnd)) ) {
//              SetForceEnd(i);
//              MbSlave.WriteBoolean(GetAddress(i,AddressData.FryingpanForceEnd),false);
//          }
//        }

        if((Boolean) RobotData.EStop.getValue()){
            YJDeviceHelper.getInstance().MainLampControl(2);
            ToastUtils.error("机器人已急停，请按复位按钮后重试！");
        }else if((Boolean) RobotData.Grating.getValue()){
            YJDeviceHelper.getInstance().MainLampControl(2);
            ToastUtils.error("光栅检测到物体，机器人已暂停工作，请按复位按钮后重试！");
        }else {
            if(RobotData.RobotIdle){
                Log.i("机器人状态","空闲");
                if(RobotData.wokWorking){
                    YJDeviceHelper.getInstance().MainLampControl(1);
                }else {
                    YJDeviceHelper.getInstance().MainLampControl(0);
                }
            }else{
                Log.i("机器人状态","工作");
                YJDeviceHelper.getInstance().MainLampControl(1);
            }
        }
    }

    @Override
    public void Control()throws InterruptedException{
        if (FryingPan.size()>0){

            for(FryingPanPar item:FryingPan.values()){

                if(RobotData.RobotIdle&&!item.IsPutIngredients ){
                    MbSlave.WriteBoolean(GetAddress(item.FryingPanNum,AddressData.PutMainMaterial),true);//写入商品ID
                    MessageLog.ShowUserMessage( UserLogEnum.订单处理日志 ,"写入准备就绪信号给"+item.FryingPanNum+"号炒锅");
                    item.IsPutIngredients=true;
                }

                //准备就绪，准备投入主料
                if(RobotData.RobotIdle && MbSlave.ReadBoolean(GetAddress(item.FryingPanNum,AddressData.AddIngredientsRequest))){

                    MbSlave.WriteBoolean(GetAddress(item.FryingPanNum,AddressData.AddIngredientsRequest),false);//复位投主料请求信号
                    RobotFeedingMainMaterials((short) item.IngredientsLocs[item.AddIngredientsCount],(short)item.FryingPanNum);//机器人投主料控制
                    item.AddIngredientsCount++;
                }
                if(EndProcess(item.FryingPanNum)) break;//强制结束检测

                //投辅料请求
                if(RobotData.RobotIdle&& MbSlave.ReadBoolean(GetAddress(item.FryingPanNum,AddressData.FryingPanRequestAccessories))){
                    int tempLoc = item.AccessoriesLocs[item.AddAccessoriesCount]+10;
                    RobotFeedingAuxiliaryMaterials((short)tempLoc,(short) item.FryingPanNum);//机器人投辅料控制
                    item.AddAccessoriesCount++;
                }
                if(EndProcess(item.FryingPanNum)) break;//强制结束检测

                //炒菜完成请求出餐
                if(RobotData.RobotIdle&&MbSlave.ReadBoolean(GetAddress(item.FryingPanNum,AddressData.RequestingMeaDelivery))){

//                    int index = GetBooleanIndex(RobotData.WarehouseLocHavingBasin,true);
                    int index=  YJDeviceHelper.getInstance().getEmptyBlowLoc();
                    if(index>=0&&index<PeripheralData.EmptyBowl.length){

                        MessageLog.ShowUserMessage( UserLogEnum.订单处理日志 ,"机器人从" +(index+1)+"号位置取空盆到"+item.FryingPanNum + "号炒锅");
                        RobotModbus.getInstance().WriteShort("GI0",(short) (index+21),1,null);//写入机器人主任务,指定取空盆位置
                        RobotModbus.getInstance().WriteShort("GI3",(short) (item.FryingPanNum),1,null);//写入机器人主任务,指定取空盆位置
                        RobotMealControl(item.FryingPanNum);//机器人出餐控制
                    }
                }
            }
            RemoveTask();//移除任务检测
        }
    }


}
