package com.bonait.bnframework.business;

import android.os.Handler;
import android.os.Looper;

import com.bonait.bnframework.HBL.NotifyPropVar;
import com.bonait.bnframework.common.constant.ConfigName;
import com.bonait.bnframework.common.helper.I.IThread;
import com.bonait.bnframework.common.helper.MessageLog;
import com.bonait.bnframework.common.helper.ThreadManager;
import com.bonait.bnframework.common.modbus.ModbusMaster;
import com.bonait.bnframework.common.model.mode.MouthFacingEnum;

import java.util.concurrent.atomic.AtomicReference;

public class FryingpanModbusBase extends ModbusMaster {
    public String Name="";
    public FryingpanModbusBase(){
        ConnectStatus.ChangeNotify=(s->{
           if(s){
               ThreadManager.Get().StartLong(Name, true, new IThread() {
                   @Override
                   public void Run() throws Exception {
                       if(TempIp.contains(ConfigName.getInstance().F1Address)){
                           ReadBool("M40.2",1,1,(s)->{
                               RobotModbus.getInstance().WriteBool(GetRobotAdd(1,0).toString(),s,1,null);//写入机器人允许放料信号
                           });
                       }else if(TempIp.contains(ConfigName.getInstance().F2Address)){
                           ReadBool("M40.2",1,1,(s)->{
                               RobotModbus.getInstance().WriteBool(GetRobotAdd(2,0).toString(),s,1,null);//写入机器人允许放料信号
                           });
                       }

                       ReadBool("M40.3",1,1,(s)->{MaterialLocFeedback =s[0];});

                       ReadBool("M10.3",1,1,(s)->{StirFeedback =s[0];});

                       ReadBool("M41.1",1,1,(s)->{ ClearLocFeedback =s[0];});

                       ReadInt("VD300",1,1,(s)->{CurrentTemperature.setValue(s[0]);});
                   }

                   @Override
                   public void RunComplete() throws Exception {

                   }
               });
           }
            DeviceConnectStatus.setValue(s);
        });
    }

    public Integer GetRobotAdd(int num,int offset){
        //M500--4596
//        return "M"+ 500+offset+(num-1)*10;
        return 4596+offset+(num-1)*10;
    }

    public void Close(){
        ThreadManager.Get().Stop(Name);
        release();
    }

    /**
     * 抽料位反馈
     */
    public boolean MaterialLocFeedback=false;

    /**
     * 搅拌反馈
     */
    public boolean StirFeedback=false;

    /**
     * 清洗位反馈
     */
    public boolean ClearLocFeedback=false;

    /**
     * 是否正在制作中
     */
    public boolean IsMake=false;

    /**
     * 当前温度
     */
    public NotifyPropVar<Integer> CurrentTemperature=new NotifyPropVar<>(0);

    public NotifyPropVar<Boolean> DeviceConnectStatus=new NotifyPropVar<>(false);

    /**
     * 料仓关联的物料名称
     */
    public String[] MaterialName;

    /**
     * 料仓控制
     * @param ce
     * @param value
     */
    public void deviceControl(ControlEnum ce, boolean value){
        try{
            String add="";
            if(ce==ControlEnum.料仓1手动开关)add="M13.1";
            else if(ce==ControlEnum.料仓2手动开关)add="M13.2";
            else if(ce==ControlEnum.料仓3手动开关)add="M13.3";
            else if(ce==ControlEnum.料仓4手动开关)add="M10.7";
            else if(ce==ControlEnum.炒锅放水)add="M11.0";
            WriteBool(add,value,1,null);
        }catch (Exception e){
            MessageLog.ShowError(e.getMessage());
        }
    }

    /**
     * 搅拌控制
     * @param frequency
     * @param status
     */
    public void setStir(short frequency,boolean status){
        try{
            WriteShort("VW102",frequency,1,null);
            WriteBool("M10.3",status,1,null);
        }catch (Exception e){
            MessageLog.ShowError(e.getMessage());
        }
    }

    /**
     * 火力设置
     * @param value
     */
    public void setFire(short value){
        try{
            WriteShort("VW100",value,1,null);
            WriteBool("M10.6",value!=0,1,null);
        }catch (Exception e){
            MessageLog.ShowError(e.getMessage());
        }
    }

    /**
     * 锅体朝向控制
     * @param mouth
     */
    public void SelfResetControl(MouthFacingEnum mouth ){
        try {
            AtomicReference<String> add = new AtomicReference<>("");
            if(mouth==MouthFacingEnum.倒菜位) add.set("M12.7");
            else if(mouth==MouthFacingEnum.抽料位) add.set("M11.7");
            else if(mouth==MouthFacingEnum.原点位) add.set("M11.4");
            else if(mouth==MouthFacingEnum.维护位) add.set("M20.0");
            else if(mouth==MouthFacingEnum.清洗位) add.set("M13.0");
            else if(mouth==MouthFacingEnum.炒菜位)  add.set("M12.0");
            else if(mouth==MouthFacingEnum.初始化) add.set("M10.0");
            else if(mouth==MouthFacingEnum.深度清洗) add.set("M13.6");
            else if(mouth==MouthFacingEnum.出菜) add.set("M11.5");
            WriteBool(add.get(), true, 1,null);
            new Handler(Looper.getMainLooper()).postDelayed(()->{
                WriteBool(add.get(), false, 1,null);
            },500);
        } catch (Exception ex) {
            MessageLog.ShowError(ex.getMessage());
        }
    }

    /**
     * 清洗抽水量设置
     * @param value
     */
    public void setPumpingCapacity(short value){
        try{
            WriteShort("VW122",value,1,null);
        }catch (Exception e){
            MessageLog.ShowError(e.getMessage());
        }
    }
}
