package com.bonait.bnframework.business;

import com.bonait.bnframework.common.constant.ConfigName;
import com.bonait.bnframework.common.db.mode.BPA_GOODS;

public  class OrderData {

    //region 单例模式
    private static OrderData mInstance; //实例变量设置私有，防止直接通过类名访问

    private OrderData() { //默认构造函数私有，防止类外直接new创建对象
    }

    public static synchronized OrderData getInstance() { //静态同步方法作为唯一的实例对象获取方式
        if (mInstance == null) {
            mInstance = new OrderData();
        }
        return mInstance;
    }


    /**
     * 商品信息
     */
    public  BPA_GOODS goods=new BPA_GOODS();

    /**
     * 主料位置
     */
    public  int MainMaterialLoc;

    /**
     * 辅料位置1
     */
    public  int AccessoriesLoc1;

    /**
     * 辅料位置2
     */
    public  int AccessoriesLoc2;


}
