package com.bonait.bnframework.business.deviceControl;

import com.bonait.bnframework.common.helper.I.IReadCallBack;
import com.bonait.bnframework.common.helper.I.IWriteCallBack;

/**设备主控模块接口，如PLC*/
public interface ControllerAble {
    void Inital(IWriteCallBack callBack);

    /**读取PLC指定地址的值
     * @param address 设备寄存器的modbus地址。
     * */
    <TDataType> TDataType ReadPLC(String address,IReadCallBack callBack);
    /**写入PLC指定地址的值
     * @param address 设备寄存器的modbus地址。
     * */
    <TDataType> void WritePLC(String address,TDataType value,IWriteCallBack callBack);
    /**打开电机，指定时间后关闭
     * @param index 料仓编号位置索引。
     * @param delayTime 关闭延迟时间，单位：ms
     * */
    void openMotorAndClose(int index,int delayTime,IWriteCallBack callBack);

    /**打开电机
     * @param index 料仓编号位置索引
     * */
    void openMotor(int index, IWriteCallBack callBack);

    /**关闭电机
     * @param index 料仓编号位置索引
     * */
    void closeMotor(int index, IWriteCallBack callBack);

    /**打开电机，指定时间后关闭
     * @param name 变量名称。
     * @param delayTime 关闭延迟时间，单位：ms
     * */
    void openMotorAndClose(String name,int delayTime,IWriteCallBack callBack);

    /**打开电机
     * @param name 变量名称。
     * */
    void openMotor(String name, IWriteCallBack callBack);

    /**关闭电机
     * @param name 变量名称。
     * */
    void closeMotor(String name, IWriteCallBack callBack);

    /**复位心跳*/
    void clrHeartbeat(IWriteCallBack callBack);

    /**读取是否超时*/
    boolean isTimeOut(IReadCallBack callBack);
}
