package com.bonait.bnframework.common.constant;

import android.app.Application;
import android.content.Context;

import com.bonait.bnframework.common.db.mode.BPA_PLCADDRESS;
import com.bonait.bnframework.common.db.mode.BPA_USER;
import com.bonait.bnframework.common.db.mode.Res_PLCADDRESS;
import com.bonait.bnframework.common.db.res.Res_PLCADDRESS1;
import com.bonait.bnframework.common.db.res.Res_ZDSF;
import com.bonait.bnframework.common.model.mode.CloudGood;
import com.bonait.bnframework.common.model.mode.DeviceInformation;
import com.bonait.bnframework.common.model.mode.OrganizeMode;
import com.bonait.bnframework.common.model.mode.ProcessT;
import com.bonait.bnframework.common.model.mode.ResALLData;
import com.bonait.bnframework.common.model.mode.ResSilosModel;
import com.bonait.bnframework.modules.home.adapter.FragmentAdapter;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.concurrent.ConcurrentHashMap;


/**
 * 配置文件
 */
public class ConfigName {
    //region 单例模式
    private static ConfigName mInstance; //实例变量设置私有，防止直接通过类名访问

    private ConfigName() { //默认构造函数私有，防止类外直接new创建对象
    }

    public static synchronized ConfigName getInstance() { //静态同步方法作为唯一的实例对象获取方式
        if (mInstance == null) {
            mInstance = new ConfigName();
        }
        return mInstance;
    }
    //endregion

    //region 程序进入界面
    public Context dishesCon;
    public Application app;
    public boolean IsPortraitScreen = true;//是否竖屏

    /**
     * 是否打开火力
     */
    public boolean IsOpenHuoLi=false;
    //endregion

    //region SD卡路径设置
    /**
     * SD卡路径
     */
    public String sdCardPath;
    /**
     * 应用程序 Res 根路径
     */
    public String appResRoot;
    /**
     * Db文件路径
     */
    public static String dbPath = "";
    //endregion

    //region 店铺配置
    /**
     * 店铺名称
     */
    public String Shop_Name = "黑菠萝奶茶机";
    /**
     * 门店Id
     */
    public String ClientAutoKey = "79";
    /**
     * 店铺设备号
     */
    public String DeviceAutoKey = "159";
    /**
     * 设备id
     */
    public String DeviceId = "未知";
    //endregion

    //region MQTT配置中心
    /**
     * 用户名
     */
    public String mqtt_userName = "emqx_u_block";
    /**
     * 密码
     */
    public String mqtt_passWord = "emqx_p_admin8765490789";
    /**
     * ip地址
     */
    public String mqtt_ip = "10.2.1.21";
    /**
     * post端口
     */
    public int mqtt_post = 1883;
    /**
     * 订阅主题
     */
    public String mqtt_topic = "DOWN/MORKT/BUSINESS/";
    public String mqtt_hearttopic = "UP/MORKT/HEARTBEAT";
    //endregion

    //region 环境配置
    /**
     * 环境配置
     */
    public String Environment = "开发环境";
    //endregion

    //region 登录信息
    /**
     * 用户信息
     */
    public BPA_USER user = new BPA_USER();
    //endregion

    //region 组织信息
    /**
     * 组织信息
     */
    public OrganizeMode organizeMode = null;
    /**
     * 设备信息
     */
    public DeviceInformation deviceInformation = null;
    //endregion

    //region 版本信息
    /**
     * 版本更新，当前版本
     */
    public String Version = "1.0";
    //endregion


    //region 是否手动下单
    /**
     * 是否手动下单
     */
    public Boolean IsUserDownOrder = false;
    //endregion

    //region PlC连接参数
    /**
     * Plc是否连接
     */
    public boolean PlcIsConnect = false;
    /**
     * 机器人IP
     */
    public String RobotAddress = "192.168.1.100";

    /**
     * 机器人连接端口
     */
    public int RobotPort = 502;

    public String F1Address="192.168.1.101";
    public int F1Port=502;

    public String F2Address="192.168.1.102";
    public int F2Port=502;

    public String DeviceAddress="192.168.1.103";
    public int DevicePort=502;

    /**
     * 炒锅1屏幕地址
     */
    public String F1HMIAddress="10.0.2.15";

    /**
     * 炒锅2屏幕地址
     */
    public String F2HMIAddress="10.0.2.15";

    /**
     * 是否有修改商品
     */
    public boolean IsChangeGoods=false;

    /**
     * Rtu串口端口号
     */
    public String SerialPortName="/dev/ttyCOM0";

    /**
     * ttl usb 端口号,扫码枪端口号
     */
    public String UsbSerialPortName="/dev/ttyS0";
    //endregion

    //region URL
    //Sass地址
    public String SaasAddress = "http://order.test1.com";
    //public String SaasAddress="https://bpa.black-pa.com:21527";
    //public String SaasAddress="https://witt.black-pa.com";
    //获取店铺详细信息 Get
    public String GetStore = "kitchen/api/StoreHelper/GetStoreInfoById?storeId=";
    //获取设备信息分页 Get
    public String GetDeviceInformation = "kitchen/api/CommInteface/GetDeviceInfo?storeId=%s&autoKey=%s";
    //获取 获取基础信息（所有物料信息、设备工序模型、菜谱列表、商品小类、商品大类、单位数据
    public String GetBaseDataModel = "kitchen/api/CommInteface/GetBaseDataModel?storeId=%s&autoKey=%s";
    //获取 商品
    public String GetGoods = "kitchen/api/CommInteface/GetDeviceGood?storeId=%s&deviceId=%s";
    //获取商品配方信息
    public String GetGoodsBom = "kitchen/api/CommInteface/GetDeviceGoodBomTechnology?goodsId=%s&deviceId=%s";
//    public String GetGoodsBom = "kitchen/api/CommInteface/GetDeviceGoodBomTechnology?goodsId=%s";
    //上传商品
    public String UpdateGoods = "kitchen/api/CommInteface/SendGoodsInfo";

    //获取商品信息
    public String GetGoodIsCloud = "kitchen/api/CommInteface/GetGoodsInfo?goodsName=%s";

    //版本更新
    public String UpdateVersion = "http://111.9.47.105:18097/api/Version/GetLatest";
    //endregion

    //region PLC地址配置
    /**
     * PLC地址，从数据库-->内存
     */
    public static ConcurrentHashMap<String, BPA_PLCADDRESS> PLC_Address = new ConcurrentHashMap<String, BPA_PLCADDRESS>();
    //region 味魔方
    /**
     * 奶茶机基础PLC模型
     */
    public List<Res_PLCADDRESS> PlcAddress_味魔方 = new ArrayList<Res_PLCADDRESS>() {{

        //通道校准
        add(new Res_PLCADDRESS("基础控制", "-------------", 0, 0));
        add(new Res_PLCADDRESS("料仓1", "M5.0", 1, 1));
        add(new Res_PLCADDRESS("料仓2", "M5.0", 1, 1));
        add(new Res_PLCADDRESS("料仓3", "M5.0", 1, 1));
        add(new Res_PLCADDRESS("料仓4", "M5.0", 1, 1));
        add(new Res_PLCADDRESS("料仓5", "M5.0", 1, 1));
        add(new Res_PLCADDRESS("料仓6", "M5.0", 1, 1));
        add(new Res_PLCADDRESS("料仓7", "M5.0", 1, 1));
        add(new Res_PLCADDRESS("料仓8", "M5.0", 1, 1));
        add(new Res_PLCADDRESS("料仓9", "M5.0", 1, 1));
        add(new Res_PLCADDRESS("料仓10", "M5.0", 1, 1));
        add(new Res_PLCADDRESS("料仓11", "M5.0", 1, 1));
        add(new Res_PLCADDRESS("料仓12", "M5.0", 1, 1));
        add(new Res_PLCADDRESS("料仓13", "M5.0", 1, 1));
        add(new Res_PLCADDRESS("料仓14", "M5.0", 1, 1));
    }};
    /**
     * 奶茶机料仓模型
     */
    public List<ResSilosModel> Silos_味魔方 = new ArrayList<ResSilosModel>() {{
        add(new ResSilosModel("粉料仓",1 , 1  ));
        add(new ResSilosModel("粉料仓",2 , 2  ));
        add(new ResSilosModel("粉料仓",3 , 3  ));
        add(new ResSilosModel("粉料仓",4 , 4  ));
        add(new ResSilosModel("粉料仓",5 , 5  ));
        add(new ResSilosModel("粉料仓",6 , 6  ));
        add(new ResSilosModel("外置仓",7 , 7  ));
        add(new ResSilosModel("外置仓",8 , 8  ));
        add(new ResSilosModel("外置仓",9 , 9  ));
        add(new ResSilosModel("外置仓",10, 10));
        add(new ResSilosModel("外置仓",11, 11));
        add(new ResSilosModel("外置仓",12, 12));
        add(new ResSilosModel("外置仓",13, 13));
        add(new ResSilosModel("外置仓",14, 14));

    }};

    /**
     * 挡位 功率
     */
    public ConcurrentHashMap<String, Integer> HeatingGear = new ConcurrentHashMap<String, Integer>() {{
        put("停止", 0);
        put("一档", 1);
        put("二档", 2);
        put("三档", 3);
        put("四档", 4);
        put("五档", 5);
        put("六档", 6);
        put("七档", 7);
        put("八档", 8);
    }};

    /**
     * 最大火力级别
     */
    public String HuoLi="八档";

    /**
     * 大炒工序模型
     */
    public List<ProcessT> Process_大炒 = new ArrayList<ProcessT>() {{
        add(new ProcessT("搅拌", Arrays.asList("搅拌速度", "延迟(秒)")));
        add(new ProcessT("位置", Arrays.asList("转动速度", "位置动作", "延迟(秒)")));
        add(new ProcessT("加热", Arrays.asList("加热功率", "延迟(秒)")));
        add(new ProcessT("主料", Arrays.asList("主料名称", "主料重量","炒制位置")));
        add(new ProcessT("液体料", new ArrayList<>()));
        add(new ProcessT("并行出料", Arrays.asList("出料克数","等待(秒)")));
        add(new ProcessT("延迟", Arrays.asList("延迟(秒)")));
        add(new ProcessT("出菜", Arrays.asList("等待(秒)")));
        add(new ProcessT("清洗", Arrays.asList("清洗方式","抽水量","等待(秒)")));
    }};
    //endreion

    //region 奶茶机
    /**
     * 奶茶机基础PLC模型
     */
    public List<Res_PLCADDRESS> PlcAddress_奶茶机 = new ArrayList<Res_PLCADDRESS>() {{

        //通道校准
        add(new Res_PLCADDRESS("通道校准", "-------------", 0, 0));
        add(new Res_PLCADDRESS("校准值1", "VW0", 1, 1));
        add(new Res_PLCADDRESS("校准值2", "VW2", 1, 1));
        add(new Res_PLCADDRESS("校准值3", "VW4", 1, 1));
        add(new Res_PLCADDRESS("校准值4", "VW6", 1, 1));
        add(new Res_PLCADDRESS("校准值5", "VW8", 1, 1));
        add(new Res_PLCADDRESS("校准值6", "VW10", 1, 1));
        add(new Res_PLCADDRESS("校准值7", "VW12", 1, 1));
        add(new Res_PLCADDRESS("校准值8", "VW14", 1, 1));
        add(new Res_PLCADDRESS("校准值9", "VW16", 1, 1));
        add(new Res_PLCADDRESS("校准值10", "VW18", 1, 1));
        add(new Res_PLCADDRESS("校准值11", "VW20", 1, 1));
        add(new Res_PLCADDRESS("校准值12", "VW22", 1, 1));
        add(new Res_PLCADDRESS("校准值13", "VW24", 1, 1));
        add(new Res_PLCADDRESS("校准值14", "VW26", 1, 1));
        add(new Res_PLCADDRESS("校准值15", "VW28", 1, 1));
        add(new Res_PLCADDRESS("校准值16", "VW30", 1, 1));
        add(new Res_PLCADDRESS("校准值17", "VW32", 1, 1));
        add(new Res_PLCADDRESS("校准值18", "VW34", 1, 1));
        add(new Res_PLCADDRESS("校准值19", "VW36", 1, 1));
        add(new Res_PLCADDRESS("校准值20", "VW38", 1, 1));

        add(new Res_PLCADDRESS("通道1校准开关", "M2.0", 1, 1));
        add(new Res_PLCADDRESS("通道2校准开关", "M2.1", 1, 1));
        add(new Res_PLCADDRESS("通道3校准开关", "M2.2", 1, 1));
        add(new Res_PLCADDRESS("通道4校准开关", "M2.3", 1, 1));
        add(new Res_PLCADDRESS("通道5校准开关", "M2.4", 1, 1));
        add(new Res_PLCADDRESS("通道6校准开关", "M2.5", 1, 1));
        add(new Res_PLCADDRESS("通道7校准开关", "M2.6", 1, 1));
        add(new Res_PLCADDRESS("通道8校准开关", "M2.7", 1, 1));
        add(new Res_PLCADDRESS("通道9校准开关", "M3.0", 1, 1));
        add(new Res_PLCADDRESS("通道10校准开关", "M3.1", 1, 1));
        add(new Res_PLCADDRESS("通道11校准开关", "M3.2", 1, 1));
        add(new Res_PLCADDRESS("通道12校准开关", "M3.3", 1, 1));
        add(new Res_PLCADDRESS("通道13校准开关", "M3.4", 1, 1));
        add(new Res_PLCADDRESS("通道14校准开关", "M3.5", 1, 1));
        add(new Res_PLCADDRESS("通道15校准开关", "M3.6", 1, 1));
        add(new Res_PLCADDRESS("通道16校准开关", "M3.7", 1, 1));
        add(new Res_PLCADDRESS("通道17校准开关", "M4.0", 1, 1));
        add(new Res_PLCADDRESS("通道18校准开关", "M4.1", 1, 1));
        add(new Res_PLCADDRESS("通道19校准开关", "M4.2", 1, 1));
        add(new Res_PLCADDRESS("通道20校准开关", "M4.3", 1, 1));

        add(new Res_PLCADDRESS("配料次数", "VD90", 1, 1));
        //add(new Res_PLCADDRESS("反转时间", "VW94", 1, 1));//pl
        add(new Res_PLCADDRESS("基准时间", "VW96", 1, 1));
        //add(new Res_PLCADDRESS("基准时间", "VW98", 1, 1));

        add(new Res_PLCADDRESS("通道校准", "M0.0", 0, 1));
        add(new Res_PLCADDRESS("校准完成", "M0.7", 1, 0));

//        add(new Res_PLCADDRESS("出料系数1", "VR400", 1, 1));
//        add(new Res_PLCADDRESS("出料系数2", "VR404", 1, 1));
//        add(new Res_PLCADDRESS("出料系数3", "VR408", 1, 1));
//        add(new Res_PLCADDRESS("出料系数4", "VR412", 1, 1));
//        add(new Res_PLCADDRESS("出料系数5", "VR416", 1, 1));
//        add(new Res_PLCADDRESS("出料系数6", "VR420", 1, 1));
//        add(new Res_PLCADDRESS("出料系数7", "VR424", 1, 1));
//        add(new Res_PLCADDRESS("出料系数8", "VR428", 1, 1));
//        add(new Res_PLCADDRESS("出料系数9", "VR432", 1, 1));
//        add(new Res_PLCADDRESS("出料系数10", "VR436", 1, 1));
//        add(new Res_PLCADDRESS("出料系数11", "VR440", 1, 1));
//        add(new Res_PLCADDRESS("出料系数12", "VR444", 1, 1));
//        add(new Res_PLCADDRESS("出料系数13", "VR448", 1, 1));
//        add(new Res_PLCADDRESS("出料系数14", "VR452", 1, 1));
//        add(new Res_PLCADDRESS("出料系数15", "VR456", 1, 1));
//        add(new Res_PLCADDRESS("出料系数16", "VR460", 1, 1));
//        add(new Res_PLCADDRESS("出料系数17", "VR464", 1, 1));
//        add(new Res_PLCADDRESS("出料系数18", "VR468", 1, 1));
//        add(new Res_PLCADDRESS("出料系数19", "VR472", 1, 1));
//        add(new Res_PLCADDRESS("出料系数20", "VR476", 1, 1));

        //模拟出料
        add(new Res_PLCADDRESS("模拟出料", "-------------", 0, 0));
        add(new Res_PLCADDRESS("需求值1", "VW100", 1, 1));
        add(new Res_PLCADDRESS("需求值2", "VW102", 1, 1));
        add(new Res_PLCADDRESS("需求值3", "VW104", 1, 1));
        add(new Res_PLCADDRESS("需求值4", "VW106", 1, 1));
        add(new Res_PLCADDRESS("需求值5", "VW108", 1, 1));
        add(new Res_PLCADDRESS("需求值6", "VW110", 1, 1));
        add(new Res_PLCADDRESS("需求值7", "VW112", 1, 1));
        add(new Res_PLCADDRESS("需求值8", "VW114", 1, 1));
        add(new Res_PLCADDRESS("需求值9", "VW116", 1, 1));
        add(new Res_PLCADDRESS("需求值10", "VW118", 1, 1));
        add(new Res_PLCADDRESS("需求值11", "VW120", 1, 1));
        add(new Res_PLCADDRESS("需求值12", "VW122", 1, 1));
        add(new Res_PLCADDRESS("需求值13", "VW124", 1, 1));
        add(new Res_PLCADDRESS("需求值14", "VW126", 1, 1));
        add(new Res_PLCADDRESS("需求值15", "VW128", 1, 1));
        add(new Res_PLCADDRESS("需求值16", "VW130", 1, 1));
        add(new Res_PLCADDRESS("需求值17", "VW132", 1, 1));
        add(new Res_PLCADDRESS("需求值18", "VW134", 1, 1));
        add(new Res_PLCADDRESS("需求值19", "VW136", 1, 1));
        add(new Res_PLCADDRESS("需求值20", "VW138", 1, 1));
        add(new Res_PLCADDRESS("配料启动", "M0.1", 0, 1));
        add(new Res_PLCADDRESS("手自切换", "M0.2", 1, 1));
        add(new Res_PLCADDRESS("配料完成", "M0.3", 1, 0));
        add(new Res_PLCADDRESS("按钮启动", "M0.5", 1, 0));

        //出料算法补偿
        add(new Res_PLCADDRESS("出料算法补偿", "-------------", 0, 0));
        add(new Res_PLCADDRESS("低系数1", "VW44", 1, 1));
        add(new Res_PLCADDRESS("低系数2", "VW46", 1, 1));
        add(new Res_PLCADDRESS("低系数3", "VW48", 1, 1));
        add(new Res_PLCADDRESS("低系数4", "VW50", 1, 1));
        add(new Res_PLCADDRESS("低系数5", "VW52", 1, 1));
        add(new Res_PLCADDRESS("低系数6", "VW54", 1, 1));

        add(new Res_PLCADDRESS("高系数1", "VW144", 1, 1));
        add(new Res_PLCADDRESS("高系数2", "VW146", 1, 1));
        add(new Res_PLCADDRESS("高系数3", "VW148", 1, 1));
        add(new Res_PLCADDRESS("高系数4", "VW150", 1, 1));
        add(new Res_PLCADDRESS("高系数5", "VW152", 1, 1));
        add(new Res_PLCADDRESS("高系数6", "VW154", 1, 1));


        add(new Res_PLCADDRESS("补偿1时间", "VW168", 1, 1));
        add(new Res_PLCADDRESS("补偿2时间", "VW170", 1, 1));
        add(new Res_PLCADDRESS("补偿3时间", "VW172", 1, 1));
        add(new Res_PLCADDRESS("补偿4时间", "VW174", 1, 1));
        add(new Res_PLCADDRESS("补偿5时间", "VW176", 1, 1));
        add(new Res_PLCADDRESS("补偿6时间", "VW178", 1, 1));

        add(new Res_PLCADDRESS("通道1补偿开关", "VW194.0", 1, 1));
        add(new Res_PLCADDRESS("通道2补偿开关", "VW194.1", 1, 1));
        add(new Res_PLCADDRESS("通道3补偿开关", "VW194.2", 1, 1));
        add(new Res_PLCADDRESS("通道4补偿开关", "VW194.3", 1, 1));
        add(new Res_PLCADDRESS("通道5补偿开关", "VW194.4", 1, 1));
        add(new Res_PLCADDRESS("通道6补偿开关", "VW194.5", 1, 1));

        //电子秤校验
        add(new Res_PLCADDRESS("电子秤校验", "-------------", 0, 0));
        add(new Res_PLCADDRESS("称当前重量", "VD344", 1, 0));
        add(new Res_PLCADDRESS("砝码值", "VW94", 1, 1));
        //add(new Res_PLCADDRESS("砝码值", "VW96", 1, 1));
        add(new Res_PLCADDRESS("砝码校准模式", "M1.0", 1, 1));
        add(new Res_PLCADDRESS("重量清零", "M1.1", 0, 1));
        add(new Res_PLCADDRESS("关闭写保护", "M1.2", 0, 1));
        add(new Res_PLCADDRESS("零点校准", "M1.3", 0, 1));
        add(new Res_PLCADDRESS("砝码值写入", "M1.4", 0, 1));
        add(new Res_PLCADDRESS("打开写保护", "M1.5", 0, 1));

        //温度监控
        add(new Res_PLCADDRESS("温度控制", "-------------", 0, 0));
        add(new Res_PLCADDRESS("果糖左温度", "VD354", 1, 0));
        add(new Res_PLCADDRESS("果糖左温度设置", "VD378", 1, 1));
        add(new Res_PLCADDRESS("果糖左温度加热", "M103.7", 1, 0));

        add(new Res_PLCADDRESS("果糖右温度", "VD358", 1, 0));
        add(new Res_PLCADDRESS("果糖右温度设置", "VD382", 1, 1));
        add(new Res_PLCADDRESS("果糖右温度加热", "M104.0", 1, 0));

        add(new Res_PLCADDRESS("水池温度", "VD362", 1, 0));
        add(new Res_PLCADDRESS("水池温度设置", "VD386", 1, 1));
        add(new Res_PLCADDRESS("水池温度加热", "M104.1", 1, 0));

//        add(new Res_PLCADDRESS("水池温度", "VD352", 1, 0));
//        add(new Res_PLCADDRESS("水池温度设置", "VD360", 1, 1));
//        add(new Res_PLCADDRESS("水池温度加热", "M104.0", 1, 0));

        //自动清洗
        add(new Res_PLCADDRESS("自动清洗", "-------------", 0, 0));
        add(new Res_PLCADDRESS("排水阀排水时间", "VW244", 1, 1));
        add(new Res_PLCADDRESS("循环清洗时间", "VW246", 1, 1));
        add(new Res_PLCADDRESS("加热时间", "VW248", 1, 1));
        add(new Res_PLCADDRESS("自动补水延迟时间", "VW250", 1, 1));


        add(new Res_PLCADDRESS("清洗模式", "M0.4", 1, 1));
        add(new Res_PLCADDRESS("自动清洗开始", "M0.5", 1, 1));
        add(new Res_PLCADDRESS("自动清洗完成", "M0.6", 1, 1));
        add(new Res_PLCADDRESS("清洗状态", "M1.6", 1, 0));


        //手动控制
        add(new Res_PLCADDRESS("手动控制", "-------------", 0, 0));
        add(new Res_PLCADDRESS("手动控制1", "M50.0", 1, 1));
        add(new Res_PLCADDRESS("手动控制2", "M50.1", 1, 1));
        add(new Res_PLCADDRESS("手动控制3", "M50.2", 1, 1));
        add(new Res_PLCADDRESS("手动控制4", "M50.3", 1, 1));
        add(new Res_PLCADDRESS("手动控制5", "M50.4", 1, 1));
        add(new Res_PLCADDRESS("手动控制6", "M50.5", 1, 1));
        add(new Res_PLCADDRESS("手动控制7", "M50.6", 1, 1));
        add(new Res_PLCADDRESS("手动控制8", "M50.7", 1, 1));
        add(new Res_PLCADDRESS("手动控制9", "M51.0", 1, 1));
        add(new Res_PLCADDRESS("手动控制10", "M51.1", 1, 1));
        add(new Res_PLCADDRESS("手动控制11", "M51.2", 1, 1));
        add(new Res_PLCADDRESS("手动控制12", "M51.3", 1, 1));
        add(new Res_PLCADDRESS("M_清洗液泵", "M51.4", 1, 1));

        add(new Res_PLCADDRESS("M_排水阀开", "M53.4", 1, 1));
        add(new Res_PLCADDRESS("M_排水阀关", "M53.5", 1, 1));
        add(new Res_PLCADDRESS("M_进水开关", "M53.6", 1, 1));
        add(new Res_PLCADDRESS("M_果糖1加热", "M53.7", 1, 1));
        add(new Res_PLCADDRESS("M_果糖2加热", "M54.0", 1, 1));
        add(new Res_PLCADDRESS("M_清洗加热", "M54.1", 1, 1));

//        add(new Res_PLCADDRESS("M_外置仓1正转", "M50.0", 1, 1));
//        add(new Res_PLCADDRESS("M_外置仓2正转", "M50.1", 1, 1));
//        add(new Res_PLCADDRESS("M_外置仓3正转", "M50.2", 1, 1));
//        add(new Res_PLCADDRESS("M_外置仓4正转", "M50.3", 1, 1));
//        add(new Res_PLCADDRESS("M_外置仓5正转", "M50.4", 1, 1));
//        add(new Res_PLCADDRESS("M_外置仓6正转", "M50.5", 1, 1));
//        add(new Res_PLCADDRESS("M_外置仓1反转", "M50.6", 1, 1));
//        add(new Res_PLCADDRESS("M_外置仓2反转", "M50.7", 1, 1));
//        add(new Res_PLCADDRESS("M_外置仓3反转", "M51.0", 1, 1));
//        add(new Res_PLCADDRESS("M_外置仓4反转", "M51.1", 1, 1));
//        add(new Res_PLCADDRESS("M_外置仓5反转", "M51.2", 1, 1));
//        add(new Res_PLCADDRESS("M_外置仓6反转", "M51.3", 1, 1));
//        add(new Res_PLCADDRESS("M_粉料通道1", "M51.4", 1, 1));
//        add(new Res_PLCADDRESS("M_粉料通道2", "M51.5", 1, 1));
//        add(new Res_PLCADDRESS("M_粉料通道3", "M51.6", 1, 1));
//        add(new Res_PLCADDRESS("M_酱油通道", "M51.7", 1, 1));
//        add(new Res_PLCADDRESS("M_醋通道", "M52.0", 1, 1));
//        add(new Res_PLCADDRESS("M_猪油通道", "M52.1", 1, 1));
//        add(new Res_PLCADDRESS("M_牛油通道", "M52.2", 1, 1));
//
//        add(new Res_PLCADDRESS("M_保温池进水阀", "M53.4", 1, 1));
//        add(new Res_PLCADDRESS("M_保温池排水阀", "M53.5", 1, 1));
//        add(new Res_PLCADDRESS("M_猪油管道保温", "M53.6", 1, 1));
//        add(new Res_PLCADDRESS("M_牛油管道保温", "M53.7", 1, 1));
//        add(new Res_PLCADDRESS("M_保温池加热", "M54.0", 1, 1));
//        add(new Res_PLCADDRESS("M_三色灯-绿", "M54.1", 1, 1));
//        add(new Res_PLCADDRESS("M_三色灯-红", "M54.2", 1, 1));

        add(new Res_PLCADDRESS("扫码数据读取", "-------------", 0, 0));
        add(new Res_PLCADDRESS("扫码数据", "VW702", 1, 0));

        add(new Res_PLCADDRESS("实时状态读取", "-------------", 0, 0));
        add(new Res_PLCADDRESS("实时状态", "VW500", 1, 0));

        add(new Res_PLCADDRESS("水池液位检测", "M5.2", 1, 0));
        add(new Res_PLCADDRESS("出料口检测", "M5.3", 1, 0));

        add(new Res_PLCADDRESS("水池进水阀", "M103.6", 1, 1));
        add(new Res_PLCADDRESS("水池排水阀-开", "M103.4", 1, 1));
        add(new Res_PLCADDRESS("水池排水阀-关", "M103.5", 1, 1));

        add(new Res_PLCADDRESS("管道自动排水", "M5.4", 1, 1));
        add(new Res_PLCADDRESS("管道自动排水完成", "M5.5", 1, 1));
    }};
    /**
     * 奶茶机料仓模型
     */
    public List<ResSilosModel> Silos_奶茶机 = new ArrayList<ResSilosModel>() {{
        add(new ResSilosModel("液体仓",1 , 1  ));
        add(new ResSilosModel("液体仓",2 , 2  ));
        add(new ResSilosModel("液体仓",3 , 3  ));
        add(new ResSilosModel("液体仓",4 , 4  ));
        add(new ResSilosModel("液体仓",5 , 5  ));
        add(new ResSilosModel("液体仓",6 , 6  ));
        add(new ResSilosModel("液体仓",7 , 7  ));
        add(new ResSilosModel("液体仓",8 , 8  ));
        add(new ResSilosModel("液体仓",9 , 9  ));
        add(new ResSilosModel("液体仓",10, 10));
        add(new ResSilosModel("果糖仓",11, 11));
        add(new ResSilosModel("果糖仓",12, 12));
    }};

    /**
     * 大炒基础PLC模型
     */
    public List<Res_PLCADDRESS1> PlcAddress_奶茶机_手动=new ArrayList<Res_PLCADDRESS1>(){{

        //硬件设备 初始化
        add(new Res_PLCADDRESS1("-------------","","加热开关控制",1,0));
        add(new Res_PLCADDRESS1("M53.7","M103.7","果糖仓加热(左)",1,1));
        add(new Res_PLCADDRESS1("M54.0","M104.0","果糖仓加热(右)",1,1));
        add(new Res_PLCADDRESS1("M54.1","M104.1","清洗池加热",1,1));
        add(new Res_PLCADDRESS1("-------------","","果糖仓泵/清洗池泵",1,0));
        add(new Res_PLCADDRESS1("M53.6","M103.6","进水阀",1,1));
        add(new Res_PLCADDRESS1("M53.4","M103.4","排水阀(开)",1,1));
        add(new Res_PLCADDRESS1("M53.5","M103.5","排水阀(关)",1,1));
        add(new Res_PLCADDRESS1("M51.4","M101.4","清洗池泵",1,1));
        add(new Res_PLCADDRESS1("M51.2","M101.2","果糖泵(左)",1,1));
        add(new Res_PLCADDRESS1("M51.3","M101.3","果糖泵(右)",1,1));
        add(new Res_PLCADDRESS1("-------------","","蠕动泵控制",1,0));
        add(new Res_PLCADDRESS1("M50.0","M100.0","蠕动泵(一)",1,1));
        add(new Res_PLCADDRESS1("M50.1","M100.1","蠕动泵(二)",1,1));
        add(new Res_PLCADDRESS1("M50.2","M100.2","蠕动泵(三)",1,1));
        add(new Res_PLCADDRESS1("M50.3","M100.3","蠕动泵(四)",1,1));
        add(new Res_PLCADDRESS1("M50.4","M100.4","蠕动泵(五)",1,1));
        add(new Res_PLCADDRESS1("-------------","","隔膜泵控制",1,0));
        add(new Res_PLCADDRESS1("M50.5","M100.5","隔膜泵(一)",1,1));
        add(new Res_PLCADDRESS1("M50.6","M100.6","隔膜泵(二)",1,1));
        add(new Res_PLCADDRESS1("M50.7","M100.7","隔膜泵(三)",1,1));
        add(new Res_PLCADDRESS1("M51.0","M101.0","隔膜泵(四)",1,1));
        add(new Res_PLCADDRESS1("M51.1","M101.1","隔膜泵(五)",1,1));

    }};

    //endregion

    //region 配料吧台


    /**
     * 配料吧台基础PLC模型
     */
    public List<Res_PLCADDRESS> PlcAddress_配料吧台 = new ArrayList<Res_PLCADDRESS>() {{

        //通道校准
        add(new Res_PLCADDRESS("通道校准", "-------------", 0, 0));
        add(new Res_PLCADDRESS("校准值1", "VW0", 1, 1));
        add(new Res_PLCADDRESS("校准值2", "VW2", 1, 1));
        add(new Res_PLCADDRESS("校准值3", "VW4", 1, 1));
        add(new Res_PLCADDRESS("校准值4", "VW6", 1, 1));
        add(new Res_PLCADDRESS("校准值5", "VW8", 1, 1));
        add(new Res_PLCADDRESS("校准值6", "VW10", 1, 1));
        add(new Res_PLCADDRESS("校准值7", "VW12", 1, 1));
        add(new Res_PLCADDRESS("校准值8", "VW14", 1, 1));
        add(new Res_PLCADDRESS("校准值9", "VW16", 1, 1));
        add(new Res_PLCADDRESS("校准值10", "VW18", 1, 1));
        add(new Res_PLCADDRESS("校准值11", "VW20", 1, 1));
        add(new Res_PLCADDRESS("校准值12", "VW22", 1, 1));
        add(new Res_PLCADDRESS("校准值13", "VW24", 1, 1));
        add(new Res_PLCADDRESS("校准值14", "VW26", 1, 1));
        add(new Res_PLCADDRESS("校准值15", "VW28", 1, 1));
        add(new Res_PLCADDRESS("校准值16", "VW30", 1, 1));
        add(new Res_PLCADDRESS("校准值17", "VW32", 1, 1));
        add(new Res_PLCADDRESS("校准值18", "VW34", 1, 1));
        add(new Res_PLCADDRESS("校准值19", "VW36", 1, 1));
        add(new Res_PLCADDRESS("校准值20", "VW38", 1, 1));

        add(new Res_PLCADDRESS("通道1校准开关", "M2.0", 1, 1));
        add(new Res_PLCADDRESS("通道2校准开关", "M2.1", 1, 1));
        add(new Res_PLCADDRESS("通道3校准开关", "M2.2", 1, 1));
        add(new Res_PLCADDRESS("通道4校准开关", "M2.3", 1, 1));
        add(new Res_PLCADDRESS("通道5校准开关", "M2.4", 1, 1));
        add(new Res_PLCADDRESS("通道6校准开关", "M2.5", 1, 1));
        add(new Res_PLCADDRESS("通道7校准开关", "M2.6", 1, 1));
        add(new Res_PLCADDRESS("通道8校准开关", "M2.7", 1, 1));
        add(new Res_PLCADDRESS("通道9校准开关", "M3.0", 1, 1));
        add(new Res_PLCADDRESS("通道10校准开关", "M3.1", 1, 1));
        add(new Res_PLCADDRESS("通道11校准开关", "M3.2", 1, 1));
        add(new Res_PLCADDRESS("通道12校准开关", "M3.3", 1, 1));
        add(new Res_PLCADDRESS("通道13校准开关", "M3.4", 1, 1));
        add(new Res_PLCADDRESS("通道14校准开关", "M3.5", 1, 1));
        add(new Res_PLCADDRESS("通道15校准开关", "M3.6", 1, 1));
        add(new Res_PLCADDRESS("通道16校准开关", "M3.7", 1, 1));
        add(new Res_PLCADDRESS("通道17校准开关", "M4.0", 1, 1));
        add(new Res_PLCADDRESS("通道18校准开关", "M4.1", 1, 1));
        add(new Res_PLCADDRESS("通道19校准开关", "M4.2", 1, 1));
        add(new Res_PLCADDRESS("通道20校准开关", "M4.3", 1, 1));

        add(new Res_PLCADDRESS("配料次数", "VD90", 1, 1));
        add(new Res_PLCADDRESS("反转时间", "VW94", 1, 1));//pl
        //add(new Res_PLCADDRESS("基准时间", "VW96", 1, 1));
        add(new Res_PLCADDRESS("基准时间", "VW98", 1, 1));

        add(new Res_PLCADDRESS("通道校准", "M0.0", 0, 1));
        add(new Res_PLCADDRESS("校准完成", "M0.7", 1, 0));

//        add(new Res_PLCADDRESS("出料系数1", "VR400", 1, 1));
//        add(new Res_PLCADDRESS("出料系数2", "VR404", 1, 1));
//        add(new Res_PLCADDRESS("出料系数3", "VR408", 1, 1));
//        add(new Res_PLCADDRESS("出料系数4", "VR412", 1, 1));
//        add(new Res_PLCADDRESS("出料系数5", "VR416", 1, 1));
//        add(new Res_PLCADDRESS("出料系数6", "VR420", 1, 1));
//        add(new Res_PLCADDRESS("出料系数7", "VR424", 1, 1));
//        add(new Res_PLCADDRESS("出料系数8", "VR428", 1, 1));
//        add(new Res_PLCADDRESS("出料系数9", "VR432", 1, 1));
//        add(new Res_PLCADDRESS("出料系数10", "VR436", 1, 1));
//        add(new Res_PLCADDRESS("出料系数11", "VR440", 1, 1));
//        add(new Res_PLCADDRESS("出料系数12", "VR444", 1, 1));
//        add(new Res_PLCADDRESS("出料系数13", "VR448", 1, 1));
//        add(new Res_PLCADDRESS("出料系数14", "VR452", 1, 1));
//        add(new Res_PLCADDRESS("出料系数15", "VR456", 1, 1));
//        add(new Res_PLCADDRESS("出料系数16", "VR460", 1, 1));
//        add(new Res_PLCADDRESS("出料系数17", "VR464", 1, 1));
//        add(new Res_PLCADDRESS("出料系数18", "VR468", 1, 1));
//        add(new Res_PLCADDRESS("出料系数19", "VR472", 1, 1));
//        add(new Res_PLCADDRESS("出料系数20", "VR476", 1, 1));

        //模拟出料
        add(new Res_PLCADDRESS("模拟出料", "-------------", 0, 0));
        add(new Res_PLCADDRESS("需求值1", "VW100", 1, 1));
        add(new Res_PLCADDRESS("需求值2", "VW102", 1, 1));
        add(new Res_PLCADDRESS("需求值3", "VW104", 1, 1));
        add(new Res_PLCADDRESS("需求值4", "VW106", 1, 1));
        add(new Res_PLCADDRESS("需求值5", "VW108", 1, 1));
        add(new Res_PLCADDRESS("需求值6", "VW110", 1, 1));
        add(new Res_PLCADDRESS("需求值7", "VW112", 1, 1));
        add(new Res_PLCADDRESS("需求值8", "VW114", 1, 1));
        add(new Res_PLCADDRESS("需求值9", "VW116", 1, 1));
        add(new Res_PLCADDRESS("需求值10", "VW118", 1, 1));
        add(new Res_PLCADDRESS("需求值11", "VW120", 1, 1));
        add(new Res_PLCADDRESS("需求值12", "VW122", 1, 1));
        add(new Res_PLCADDRESS("需求值13", "VW124", 1, 1));
        add(new Res_PLCADDRESS("需求值14", "VW126", 1, 1));
        add(new Res_PLCADDRESS("需求值15", "VW128", 1, 1));
        add(new Res_PLCADDRESS("需求值16", "VW130", 1, 1));
        add(new Res_PLCADDRESS("需求值17", "VW132", 1, 1));
        add(new Res_PLCADDRESS("需求值18", "VW134", 1, 1));
        add(new Res_PLCADDRESS("需求值19", "VW136", 1, 1));
        add(new Res_PLCADDRESS("需求值20", "VW138", 1, 1));
        add(new Res_PLCADDRESS("配料启动", "M0.1", 0, 1));
        add(new Res_PLCADDRESS("手自切换", "M0.2", 1, 1));
        add(new Res_PLCADDRESS("配料完成", "M0.3", 1, 0));
        add(new Res_PLCADDRESS("按钮启动", "M0.5", 1, 0));

        //出料算法补偿
        add(new Res_PLCADDRESS("出料算法补偿", "-------------", 0, 0));
        add(new Res_PLCADDRESS("低系数1", "VW44", 1, 1));
        add(new Res_PLCADDRESS("低系数2", "VW46", 1, 1));
        add(new Res_PLCADDRESS("低系数3", "VW48", 1, 1));
        add(new Res_PLCADDRESS("低系数4", "VW50", 1, 1));
        add(new Res_PLCADDRESS("低系数5", "VW52", 1, 1));
        add(new Res_PLCADDRESS("低系数6", "VW54", 1, 1));

        add(new Res_PLCADDRESS("高系数1", "VW144", 1, 1));
        add(new Res_PLCADDRESS("高系数2", "VW146", 1, 1));
        add(new Res_PLCADDRESS("高系数3", "VW148", 1, 1));
        add(new Res_PLCADDRESS("高系数4", "VW150", 1, 1));
        add(new Res_PLCADDRESS("高系数5", "VW152", 1, 1));
        add(new Res_PLCADDRESS("高系数6", "VW154", 1, 1));


        add(new Res_PLCADDRESS("补偿1时间", "VW168", 1, 1));
        add(new Res_PLCADDRESS("补偿2时间", "VW170", 1, 1));
        add(new Res_PLCADDRESS("补偿3时间", "VW172", 1, 1));
        add(new Res_PLCADDRESS("补偿4时间", "VW174", 1, 1));
        add(new Res_PLCADDRESS("补偿5时间", "VW176", 1, 1));
        add(new Res_PLCADDRESS("补偿6时间", "VW178", 1, 1));

        add(new Res_PLCADDRESS("通道1补偿开关", "VW194.0", 1, 1));
        add(new Res_PLCADDRESS("通道2补偿开关", "VW194.1", 1, 1));
        add(new Res_PLCADDRESS("通道3补偿开关", "VW194.2", 1, 1));
        add(new Res_PLCADDRESS("通道4补偿开关", "VW194.3", 1, 1));
        add(new Res_PLCADDRESS("通道5补偿开关", "VW194.4", 1, 1));
        add(new Res_PLCADDRESS("通道6补偿开关", "VW194.5", 1, 1));

        //电子秤校验
        add(new Res_PLCADDRESS("电子秤校验", "-------------", 0, 0));
        add(new Res_PLCADDRESS("称当前重量", "VD344", 1, 0));
        //add(new Res_PLCADDRESS("砝码值", "VW94", 1, 1));
        add(new Res_PLCADDRESS("砝码值", "VW96", 1, 1));
        add(new Res_PLCADDRESS("砝码校准模式", "M1.0", 1, 1));
        add(new Res_PLCADDRESS("重量清零", "M1.1", 0, 1));
        add(new Res_PLCADDRESS("关闭写保护", "M1.2", 0, 1));
        add(new Res_PLCADDRESS("零点校准", "M1.3", 0, 1));
        add(new Res_PLCADDRESS("砝码值写入", "M1.4", 0, 1));
        add(new Res_PLCADDRESS("打开写保护", "M1.5", 0, 1));
        add(new Res_PLCADDRESS("清洗状态", "M1.6", 1, 0));

        //温度监控
        add(new Res_PLCADDRESS("温度控制", "-------------", 0, 0));
//        add(new Res_PLCADDRESS("水池温度", "VD354", 1, 0));
//        add(new Res_PLCADDRESS("水池温度设置", "VD378", 1, 1));
//        add(new Res_PLCADDRESS("水池温度加热", "M104.1", 1, 0));
//
//        add(new Res_PLCADDRESS("果糖左温度", "VD358", 1, 0));
//        add(new Res_PLCADDRESS("果糖左温度设置", "VD382", 1, 1));
//        add(new Res_PLCADDRESS("果糖左温度加热", "M103.7", 1, 0));
//
//        add(new Res_PLCADDRESS("果糖右温度", "VD362", 1, 0));
//        add(new Res_PLCADDRESS("果糖右温度设置", "VD386", 1, 1));
//        add(new Res_PLCADDRESS("果糖右温度加热", "M104.0", 1, 0));

        add(new Res_PLCADDRESS("水池温度", "VD352", 1, 0));
        add(new Res_PLCADDRESS("水池温度设置", "VD360", 1, 1));
        add(new Res_PLCADDRESS("水池温度加热", "M104.0", 1, 0));

        //自动清洗
        add(new Res_PLCADDRESS("自动清洗", "-------------", 0, 0));
        add(new Res_PLCADDRESS("排水阀排水时间", "VW244", 1, 1));
        add(new Res_PLCADDRESS("循环清洗时间", "VW246", 1, 1));
        add(new Res_PLCADDRESS("加热时间", "VW248", 1, 1));
        add(new Res_PLCADDRESS("自动补水延迟时间", "VW250", 1, 1));


        add(new Res_PLCADDRESS("清洗模式", "M0.4", 1, 1));
        add(new Res_PLCADDRESS("自动清洗开始", "M0.5", 1, 1));
        add(new Res_PLCADDRESS("自动清洗完成", "M0.6", 1, 1));


        //手动控制
        add(new Res_PLCADDRESS("手动控制", "-------------", 0, 0));
        add(new Res_PLCADDRESS("手动控制1", "M50.0", 1, 1));
        add(new Res_PLCADDRESS("手动控制2", "M50.1", 1, 1));
        add(new Res_PLCADDRESS("手动控制3", "M50.2", 1, 1));
        add(new Res_PLCADDRESS("手动控制4", "M50.3", 1, 1));
        add(new Res_PLCADDRESS("手动控制5", "M50.4", 1, 1));
        add(new Res_PLCADDRESS("手动控制6", "M50.5", 1, 1));
        add(new Res_PLCADDRESS("手动控制7", "M51.4", 1, 1));
        add(new Res_PLCADDRESS("手动控制8", "M51.5", 1, 1));
        add(new Res_PLCADDRESS("手动控制9", "M51.6", 1, 1));
        add(new Res_PLCADDRESS("手动控制10", "M51.7", 1, 1));
        add(new Res_PLCADDRESS("手动控制11", "M52.0", 1, 1));
        add(new Res_PLCADDRESS("手动控制12", "M52.1", 1, 1));
        add(new Res_PLCADDRESS("手动控制13", "M52.2", 1, 1));
        add(new Res_PLCADDRESS("手动控制14", "M52.3", 1, 1));
        add(new Res_PLCADDRESS("手动控制15", "M52.4", 1, 1));
        add(new Res_PLCADDRESS("手动控制16", "M52.5", 1, 1));


        add(new Res_PLCADDRESS("M_外置仓1反转", "M50.6", 1, 1));
        add(new Res_PLCADDRESS("M_外置仓2反转", "M50.7", 1, 1));
        add(new Res_PLCADDRESS("M_外置仓3反转", "M51.0", 1, 1));
        add(new Res_PLCADDRESS("M_外置仓4反转", "M51.1", 1, 1));
        add(new Res_PLCADDRESS("M_外置仓5反转", "M51.2", 1, 1));
        add(new Res_PLCADDRESS("M_外置仓6反转", "M51.3", 1, 1));


        add(new Res_PLCADDRESS("保温池进水阀", "M103.4", 1, 1));
        add(new Res_PLCADDRESS("保温池排水阀", "M103.5", 1, 1));
        add(new Res_PLCADDRESS("猪油管道保温", "M103.6", 1, 1));
        add(new Res_PLCADDRESS("牛油管道保温", "M103.7", 1, 1));
        add(new Res_PLCADDRESS("保温池加热", "M104.0", 1, 1));
        add(new Res_PLCADDRESS("三色灯-绿", "M104.1", 1, 1));
        add(new Res_PLCADDRESS("三色灯-红", "M104.2", 1, 1));

//        add(new Res_PLCADDRESS("M_保温池进水阀", "M53.4", 1, 1));
//        add(new Res_PLCADDRESS("M_保温池排水阀", "M53.5", 1, 1));
//        add(new Res_PLCADDRESS("M_猪油管道保温", "M53.6", 1, 1));
//        add(new Res_PLCADDRESS("M_牛油管道保温", "M53.7", 1, 1));
//        add(new Res_PLCADDRESS("M_保温池加热", "M54.0", 1, 1));
//        add(new Res_PLCADDRESS("M_三色灯-绿", "M54.1", 1, 1));
//        add(new Res_PLCADDRESS("M_三色灯-红", "M54.2", 1, 1));

        add(new Res_PLCADDRESS("扫码数据读取", "-------------", 0, 0));
        add(new Res_PLCADDRESS("扫码数据", "VW702", 1, 0));

        add(new Res_PLCADDRESS("实时状态读取", "-------------", 0, 0));
        add(new Res_PLCADDRESS("实时状态", "VW500", 1, 0));
        add(new Res_PLCADDRESS("水池液位检测", "M5.2", 1, 0));
        add(new Res_PLCADDRESS("出料口检测", "M5.3", 1, 0));
        add(new Res_PLCADDRESS("水池进水阀", "M103.4", 1, 1));
        add(new Res_PLCADDRESS("水池排水阀-开", "M103.5", 1, 1));
        add(new Res_PLCADDRESS("水池排水阀-关", "M103.5", 1, 1));

        add(new Res_PLCADDRESS("管道自动排水", "M5.4", 1, 1));
        add(new Res_PLCADDRESS("管道自动排水完成", "M5.5", 1, 1));

    }};
    /**
     * 配料吧台料仓模型
     */
    public List<ResSilosModel> Silos_配料吧台 = new ArrayList<ResSilosModel>() {{
        add(new ResSilosModel("外置仓",1 , 1  ));
        add(new ResSilosModel("外置仓",2 , 2  ));
        add(new ResSilosModel("外置仓",3 , 3  ));
        add(new ResSilosModel("外置仓",4 , 4  ));
        add(new ResSilosModel("外置仓",5 , 5  ));
        add(new ResSilosModel("外置仓",6 , 6  ));
        add(new ResSilosModel("粉料仓",7 , 7  ));
        add(new ResSilosModel("粉料仓",8 , 8  ));
        add(new ResSilosModel("粉料仓",9 , 9  ));
        add(new ResSilosModel("液料仓",13, 10));
        add(new ResSilosModel("液料仓",14, 11));
        add(new ResSilosModel("加热仓",15, 12));
        add(new ResSilosModel("加热仓",16, 13));
        add(new ResSilosModel("粉料仓",10, 14));
        add(new ResSilosModel("粉料仓",11, 15));
        add(new ResSilosModel("粉料仓",12, 16));
    }};

    /**
     * 配料吧台PLC模型
     */
    public List<Res_PLCADDRESS1> PlcAddress_配料吧台_手动=new ArrayList<Res_PLCADDRESS1>(){{

        //硬件设备 初始化
        add(new Res_PLCADDRESS1("-------------","","酱油仓/猪油仓",1,0));
        add(new Res_PLCADDRESS1("M51.7","M101.7","酱油仓控制",0,1));
        add(new Res_PLCADDRESS1("M52.0","M102.0","醋仓控制",0,1));
        add(new Res_PLCADDRESS1("M52.1","M102.1","猪油仓控制",0,1));
        add(new Res_PLCADDRESS1("M52.2","M102.2","牛油仓控制",0,1));
        add(new Res_PLCADDRESS1("M53.6","M103.6","猪油管道保温",1,1));
        add(new Res_PLCADDRESS1("M53.7","M103.7","牛油管道保温",1,1));
        add(new Res_PLCADDRESS1("-------------","","外置仓",1,0));
        add(new Res_PLCADDRESS1("M50.0","M100.0","外置仓正转(1)",1,1));
        add(new Res_PLCADDRESS1("M50.1","M100.1","外置仓正转(2)",1,1));
        add(new Res_PLCADDRESS1("M50.2","M100.2","外置仓正转(3)",1,1));
        add(new Res_PLCADDRESS1("M50.3","M100.3","外置仓正转(4)",1,1));
        add(new Res_PLCADDRESS1("M50.4","M100.4","外置仓正转(5)",1,1));
        add(new Res_PLCADDRESS1("M50.5","M100.5","外置仓正转(6)",1,1));
        add(new Res_PLCADDRESS1("M50.6","M100.6","外置仓反转(1)",1,1));
        add(new Res_PLCADDRESS1("M50.7","M100.7","外置仓反转(2)",1,1));
        add(new Res_PLCADDRESS1("M51.0","M101.0","外置仓反转(3)",1,1));
        add(new Res_PLCADDRESS1("M51.1","M101.1","外置仓反转(4)",1,1));
        add(new Res_PLCADDRESS1("M51.2","M101.2","外置仓反转(5)",1,1));
        add(new Res_PLCADDRESS1("M51.3","M101.3","外置仓反转(6)",1,1));
        add(new Res_PLCADDRESS1("-------------","","粉料仓",0,0));
        add(new Res_PLCADDRESS1("M51.4","M101.4","粉料仓控制(1)",0,1));
        add(new Res_PLCADDRESS1("M51.5","M101.5","粉料仓控制(2)",0,1));
        add(new Res_PLCADDRESS1("M51.6","M101.6","粉料仓控制(3)",0,1));
        add(new Res_PLCADDRESS1("M52.3","M102.3","粉料仓控制(4)",0,1));
        add(new Res_PLCADDRESS1("M52.4","M102.4","粉料仓控制(5)",0,1));
        add(new Res_PLCADDRESS1("M52.5","M102.5","粉料仓控制(6)",0,1));

        add(new Res_PLCADDRESS1("-------------","","水池",1,0));
        add(new Res_PLCADDRESS1("M53.4","M103.4","水池进水阀",1,1));
        add(new Res_PLCADDRESS1("M53.5","M103.5","水池排水阀",1,1));
        add(new Res_PLCADDRESS1("M54.0","M104.0","水池加热",1,1));

    }};

    /**
     * 出料算法
     */
    public List<Res_ZDSF> zdsfs_出料算法=new ArrayList<Res_ZDSF>(){{
        //硬件设备 初始化
        add(new Res_ZDSF("外置通道(一)","VW194.0","VW144","VW44","VW168"));
        add(new Res_ZDSF("外置通道(二)","VW194.1","VW146","VW46","VW170"));
        add(new Res_ZDSF("外置通道(三)","VW194.2","VW148","VW48","VW172"));
        add(new Res_ZDSF("外置通道(四)","VW194.3","VW150","VW50","VW174"));
        add(new Res_ZDSF("外置通道(五)","VW194.4","VW152","VW52","VW176"));
        add(new Res_ZDSF("外置通道(六)","VW194.5","VW154","VW54","VW178"));
//        add(new Res_ZDSF("外置通道(七)","VW194.6","VW156","VW56","VW180"));
//        add(new Res_ZDSF("外置通道(八)","VW194.7","VW158","VW58","VW182"));
//        add(new Res_ZDSF("外置通道(九)","VW194.8","VW160","VW60","VW184"));
//        add(new Res_ZDSF("外置通道(十)","VW194.9","VW162","VW62","VW186"));
    }};

    //endregion

    //region 新版调味吧台
    /**
     * 新版调味吧台
     */
    public List<Res_PLCADDRESS> PlcAddress_调味吧台 = new ArrayList<Res_PLCADDRESS>() {{
        add(new Res_PLCADDRESS("心跳时间","D0",1 , 1  ));
        add(new Res_PLCADDRESS("外置仓正转1","D1",1 , 1  ));
        add(new Res_PLCADDRESS("外置仓正转2","D2",1 , 1  ));
        add(new Res_PLCADDRESS("外置仓正转3","D3",1 , 1  ));
        add(new Res_PLCADDRESS("外置仓正转4","D4",1 , 1  ));
        add(new Res_PLCADDRESS("外置仓正转5","D5",1 , 1  ));
        add(new Res_PLCADDRESS("外置仓正转6","D6",1 , 1  ));
        add(new Res_PLCADDRESS("加热仓正转1","D7",1 , 1  ));
        add(new Res_PLCADDRESS("加热仓正转2","D8",1 , 1  ));
        add(new Res_PLCADDRESS("外置仓反转1","D9",1 , 1  ));
        add(new Res_PLCADDRESS("外置仓反转2","D10",1 , 1  ));
        add(new Res_PLCADDRESS("外置仓反转3","D11",1, 1));
        add(new Res_PLCADDRESS("外置仓反转4","D12",1, 1));
        add(new Res_PLCADDRESS("外置仓反转5","D13",1, 1));
        add(new Res_PLCADDRESS("外置仓反转6","D14",1, 1));
        add(new Res_PLCADDRESS("加热仓反转1","D15",1, 1));
        add(new Res_PLCADDRESS("加热仓反转2","D16",1, 1));
        add(new Res_PLCADDRESS("粉料仓1","D17",1, 1));
        add(new Res_PLCADDRESS("粉料仓2","D18",1, 1));
        add(new Res_PLCADDRESS("粉料仓3","D19",1, 1));
        add(new Res_PLCADDRESS("粉料仓4","D20",1, 1));
        add(new Res_PLCADDRESS("粉料仓5","D21",1, 1));
        add(new Res_PLCADDRESS("粉料仓6","D22",1, 1));
        add(new Res_PLCADDRESS("普通液体仓1","D23",1, 1));
        add(new Res_PLCADDRESS("普通液体仓2","D24",1, 1));
        add(new Res_PLCADDRESS("进水阀","D40",1, 1));
        add(new Res_PLCADDRESS("排水阀","D41",1, 1));
        add(new Res_PLCADDRESS("加热仓管道1","D42",1, 1));
        add(new Res_PLCADDRESS("加热仓管道2","D43",1, 1));
        add(new Res_PLCADDRESS("三色灯红","D44",1, 1));
        add(new Res_PLCADDRESS("三色灯绿","D45",1, 1));
        add(new Res_PLCADDRESS("三色灯黄","D46",1, 1));
        add(new Res_PLCADDRESS("清洗加热","D47",1, 1));
        add(new Res_PLCADDRESS("清洗温度","D85",1, 1));

        add(new Res_PLCADDRESS("断线标志","M0",1, 0));
        add(new Res_PLCADDRESS("按钮启动","M1",1, 1));
        add(new Res_PLCADDRESS("清洗液位","M2",1, 1));
    }};

    /**
     * 新版调味吧台料仓模型
     */
    public List<ResSilosModel> Silos_调味吧台 = new ArrayList<ResSilosModel>() {{
        add(new ResSilosModel("外置仓",1 , 1  ));
        add(new ResSilosModel("外置仓",2 , 2  ));
        add(new ResSilosModel("外置仓",3 , 3  ));
        add(new ResSilosModel("外置仓",4 , 4  ));
        add(new ResSilosModel("外置仓",5 , 5  ));
        add(new ResSilosModel("外置仓",6 , 6  ));
        add(new ResSilosModel("加热仓",7 , 7  ));
        add(new ResSilosModel("加热仓",8 , 8  ));
        add(new ResSilosModel("粉料仓",9 , 9  ));
        add(new ResSilosModel("粉料仓",10, 10));
        add(new ResSilosModel("粉料仓",11, 11));
        add(new ResSilosModel("粉料仓",12, 12));
        add(new ResSilosModel("粉料仓",13, 13));
        add(new ResSilosModel("粉料仓",14, 14));
        add(new ResSilosModel("液体仓",15, 15));
        add(new ResSilosModel("液体仓",16, 16));

    }};

    //endregion

    /**
     * 一拖四基础PLC模型
     */
    public List<Res_PLCADDRESS> PlcAddress_一拖四 = new ArrayList<Res_PLCADDRESS>() {{

        //硬件设备 初始化
        add(new Res_PLCADDRESS("硬件设备", "-------------", 0, 0));
        add(new Res_PLCADDRESS("初始化", "M10.0", 1, 1));
        add(new Res_PLCADDRESS("停止", "M10.1", 1, 1));
        add(new Res_PLCADDRESS("复位", "M10.2", 0, 1));

        //搅拌模型
        add(new Res_PLCADDRESS("模型控制", "-------------", 0, 0));
        add(new Res_PLCADDRESS("搅拌", "M10.3", 1, 1));
        add(new Res_PLCADDRESS("搅拌速度", "VW102", 1, 1));

        //翻转正转模型
        add(new Res_PLCADDRESS("翻转正转", "M10.4", 0, 1));
        add(new Res_PLCADDRESS("翻转反转", "M10.5", 0, 1));
        add(new Res_PLCADDRESS("转动速度", "VW104", 1, 1));


        //加热模型
        add(new Res_PLCADDRESS("加热", "M10.6", 0, 1));
        add(new Res_PLCADDRESS("加热功率", "VW100", 1, 1));
        add(new Res_PLCADDRESS("温控开关", "M17.6", 1, 1));
        add(new Res_PLCADDRESS("暂停开关", "M17.7", 1, 1));

        //主料
        add(new Res_PLCADDRESS("主料1号位", "M17.4", 0, 1));
        add(new Res_PLCADDRESS("主料2号位", "M19.4", 0, 1));

        //抽水放水
        add(new Res_PLCADDRESS("炒锅抽水", "M10.7", 0, 1));
        add(new Res_PLCADDRESS("炒锅放水", "M11.0", 0, 1));


        //出菜模型
        add(new Res_PLCADDRESS("出菜", "M11.5", 0, 1));


        //位置动作
        add(new Res_PLCADDRESS("原点位", "M11.4", 0, 1));
        add(new Res_PLCADDRESS("倒菜位", "M12.7", 0, 1));
        add(new Res_PLCADDRESS("维护位", "M20.0", 0, 1));
        add(new Res_PLCADDRESS("抽料位", "M11.7", 0, 1));
        add(new Res_PLCADDRESS("清洗位", "M13.0", 0, 1));
        add(new Res_PLCADDRESS("炒菜位1", "M12.0", 0, 1));
        add(new Res_PLCADDRESS("炒菜位2", "M12.1", 0, 1));
        add(new Res_PLCADDRESS("炒菜位3", "M12.2", 0, 1));

        add(new Res_PLCADDRESS("出餐启动", "M11.5", 0, 1));
        add(new Res_PLCADDRESS("炒锅清洗", "M11.6", 0, 1));

        //深度清洗功能
        add(new Res_PLCADDRESS("深度清洗功能", "-------------", 0, 0));
        add(new Res_PLCADDRESS("清洗抽水量", "VW122", 1, 1));
        add(new Res_PLCADDRESS("清洗时间", "VW1150", 1, 1));
        add(new Res_PLCADDRESS("倒水减速角度", "VW1152", 1, 1));
        add(new Res_PLCADDRESS("深度清洗", "M13.6", 0, 1));
        add(new Res_PLCADDRESS("编码器复位", "M13.7", 0, 1));

        //液体料模型
        add(new Res_PLCADDRESS("料仓校准", "-------------", 0, 0));
        add(new Res_PLCADDRESS("校准时间", "VW112", 1, 1));
        add(new Res_PLCADDRESS("料仓1校准开关", "M12.3", 0, 1));
        add(new Res_PLCADDRESS("料仓1校准值", "VW114", 1, 1));
        add(new Res_PLCADDRESS("料仓2校准开关", "M12.4", 0, 1));
        add(new Res_PLCADDRESS("料仓2校准值", "VW116", 1, 1));
        add(new Res_PLCADDRESS("料仓3校准开关", "M12.5", 0, 1));
        add(new Res_PLCADDRESS("料仓3校准值", "VW118", 1, 1));
        add(new Res_PLCADDRESS("料仓4校准开关", "M13.5", 0, 1));
        add(new Res_PLCADDRESS("料仓4校准值", "VW120", 1, 1));
        add(new Res_PLCADDRESS("开始校正", "M12.6", 0, 1));

        add(new Res_PLCADDRESS("料仓自动", "-------------", 0, 0));
        add(new Res_PLCADDRESS("料仓1需求值", "VW106", 1, 1));
        add(new Res_PLCADDRESS("料仓1下料", "M11.1", 0, 1));
        add(new Res_PLCADDRESS("料仓2需求值", "VW108", 1, 1));
        add(new Res_PLCADDRESS("料仓2下料", "M11.2", 0, 1));
        add(new Res_PLCADDRESS("料仓3需求值", "VW110", 1, 1));
        add(new Res_PLCADDRESS("料仓3下料", "M11.3", 0, 1));
        add(new Res_PLCADDRESS("料仓4需求值", "VW122", 1, 1));
        add(new Res_PLCADDRESS("料仓4下料", "M13.4", 0, 1));

        add(new Res_PLCADDRESS("料仓手动", "-------------", 0, 0));
        add(new Res_PLCADDRESS("料仓1手动开关", "M13.1", 1, 1));
        add(new Res_PLCADDRESS("料仓2手动开关", "M13.2", 1, 1));
        add(new Res_PLCADDRESS("料仓3手动开关", "M13.3", 1, 1));
        add(new Res_PLCADDRESS("料仓4手动开关", "M10.7", 1, 1));

        //上下限
        add(new Res_PLCADDRESS("位置上下限", "-------------", 0, 0));
        add(new Res_PLCADDRESS("原点位置下限", "VD150", 1, 1));
        add(new Res_PLCADDRESS("原点位置上限", "VD154", 1, 1));
        add(new Res_PLCADDRESS("维护位置下限", "VD1130", 1, 1));
        add(new Res_PLCADDRESS("维护位置上限", "VD1134", 1, 1));
        add(new Res_PLCADDRESS("洗锅位置下限", "VD158", 1, 1));
        add(new Res_PLCADDRESS("洗锅位置上限", "VD162", 1, 1));
        add(new Res_PLCADDRESS("倒菜位置下限", "VD166", 1, 1));
        add(new Res_PLCADDRESS("倒菜位置上限", "VD170", 1, 1));
        add(new Res_PLCADDRESS("抽调料位置下限", "VD174", 1, 1));
        add(new Res_PLCADDRESS("抽调料位置上限", "VD178", 1, 1));
        add(new Res_PLCADDRESS("1#炒制位置下限", "VD182", 1, 1));
        add(new Res_PLCADDRESS("1#炒制位置上限", "VD186", 1, 1));
        add(new Res_PLCADDRESS("2#炒制位置下限", "VD190", 1, 1));
        add(new Res_PLCADDRESS("2#炒制位置上限", "VD194", 1, 1));
        add(new Res_PLCADDRESS("3#炒制位置下限", "VD198", 1, 1));
        add(new Res_PLCADDRESS("3#炒制位置上限", "VD202", 1, 1));
        add(new Res_PLCADDRESS("炒锅工作范围下限", "VD206", 1, 1));
        add(new Res_PLCADDRESS("炒锅工作范围上限", "VD210", 1, 1));

        //自动投料-平移轴
//        add(new Res_PLCADDRESS("平移轴控制", "-------------", 0, 0));
//        add(new Res_PLCADDRESS("平移-伺服当前值", "VD220", 1, 1));
//        add(new Res_PLCADDRESS("平移-点动速度", "VD224", 1, 1));
//        add(new Res_PLCADDRESS("平移-回原点速度", "VD228", 1, 1));
//        add(new Res_PLCADDRESS("平移-定位运行速度", "VD232", 1, 1));
//
//        add(new Res_PLCADDRESS("平移-点动正转", "M14.0", 0, 1));
//        add(new Res_PLCADDRESS("平移-点动反转", "M14.1", 0, 1));
//        add(new Res_PLCADDRESS("平移-回原点", "M14.2", 0, 1));
//        add(new Res_PLCADDRESS("平移-去1号位", "M14.3", 0, 1));
//        add(new Res_PLCADDRESS("平移-去2号位", "M14.4", 0, 1));
//        add(new Res_PLCADDRESS("平移-去3号位", "M14.5", 0, 1));
//        add(new Res_PLCADDRESS("平移-去4号位", "M14.6", 0, 1));
//
//        add(new Res_PLCADDRESS("平移-1号位置值", "VD236", 1, 1));
//        add(new Res_PLCADDRESS("平移-1#位置设定", "M15.0", 0, 1));
//        add(new Res_PLCADDRESS("平移-2号位置值", "VD240", 1, 1));
//        add(new Res_PLCADDRESS("平移-2#位置设定", "M15.1", 0, 1));
//        add(new Res_PLCADDRESS("平移-3号位置值", "VD244", 1, 1));
//        add(new Res_PLCADDRESS("平移-3#位置设定", "M15.2", 0, 1));
//        add(new Res_PLCADDRESS("平移-4号位置值", "VD248", 1, 1));
//        add(new Res_PLCADDRESS("平移-4#位置设定", "M15.3", 0, 1));

        //自动投料-翻转轴
        add(new Res_PLCADDRESS("翻转轴控制1", "-------------", 0, 0));
        add(new Res_PLCADDRESS("翻转1-伺服当前值", "VD260", 1, 1));
        add(new Res_PLCADDRESS("翻转1-点动速度", "VD264", 1, 1));
        add(new Res_PLCADDRESS("翻转1-回原点速度", "VD268", 1, 1));
        add(new Res_PLCADDRESS("翻转1-定位运行速度", "VD272", 1, 1));

        add(new Res_PLCADDRESS("翻转1-点动正转", "M16.0", 0, 1));
        add(new Res_PLCADDRESS("翻转1-点动反转", "M16.1", 0, 1));
        add(new Res_PLCADDRESS("翻转1-回原点", "M16.2", 0, 1));
        add(new Res_PLCADDRESS("翻转1-去1号位", "M16.3", 0, 1));
        add(new Res_PLCADDRESS("翻转1-去2号位", "M16.4", 0, 1));
        add(new Res_PLCADDRESS("翻转1-去3号位", "M16.5", 0, 1));
        add(new Res_PLCADDRESS("翻转1-去4号位", "M16.6", 0, 1));

        add(new Res_PLCADDRESS("翻转1-1号位置值", "VD276", 1, 1));
        add(new Res_PLCADDRESS("翻转1-1#位置设定", "M17.0", 0, 1));
        add(new Res_PLCADDRESS("翻转1-2号位置值", "VD280", 1, 1));
        add(new Res_PLCADDRESS("翻转1-2#位置设定", "M17.1", 0, 1));
        add(new Res_PLCADDRESS("翻转1-3号位置值", "VD284", 1, 1));
        add(new Res_PLCADDRESS("翻转1-3#位置设定", "M17.2", 0, 1));
        add(new Res_PLCADDRESS("翻转1-4号位置值", "VD288", 1, 1));
        add(new Res_PLCADDRESS("翻转1-4#位置设定", "M17.3", 0, 1));
        add(new Res_PLCADDRESS("倒菜启动1", "M17.4", 0, 1));

        add(new Res_PLCADDRESS("翻转轴控制2", "-------------", 0, 0));
        add(new Res_PLCADDRESS("翻转2-伺服当前值", "VD2000", 1, 1));
        add(new Res_PLCADDRESS("翻转2-点动速度", "VD2004", 1, 1));
        add(new Res_PLCADDRESS("翻转2-回原点速度", "VD2008", 1, 1));
        add(new Res_PLCADDRESS("翻转2-定位运行速度", "VD2012", 1, 1));

        add(new Res_PLCADDRESS("翻转2-点动正转", "M18.0", 0, 1));
        add(new Res_PLCADDRESS("翻转2-点动反转", "M18.1", 0, 1));
        add(new Res_PLCADDRESS("翻转2-回原点",  "M18.2", 0, 1));
        add(new Res_PLCADDRESS("翻转2-去1号位", "M18.3", 0, 1));
        add(new Res_PLCADDRESS("翻转2-去2号位", "M18.4", 0, 1));
        add(new Res_PLCADDRESS("翻转2-去3号位", "M18.5", 0, 1));
        add(new Res_PLCADDRESS("翻转2-去4号位", "M18.6", 0, 1));

        add(new Res_PLCADDRESS("翻转2-1号位置值", "VD2016", 1, 1));
        add(new Res_PLCADDRESS("翻转2-1#位置设定", "M19.0", 0, 1));
        add(new Res_PLCADDRESS("翻转2-2号位置值", "VD2020", 1, 1));
        add(new Res_PLCADDRESS("翻转2-2#位置设定", "M19.1", 0, 1));
        add(new Res_PLCADDRESS("翻转2-3号位置值", "VD2024", 1, 1));
        add(new Res_PLCADDRESS("翻转2-3#位置设定", "M19.2", 0, 1));
        add(new Res_PLCADDRESS("翻转2-4号位置值", "VD2028", 1, 1));
        add(new Res_PLCADDRESS("翻转2-4#位置设定", "M19.3", 0, 1));
        add(new Res_PLCADDRESS("倒菜启动2", "M19.4", 0, 1));


        add(new Res_PLCADDRESS("温度模拟输入量", "-------------", 0, 0));
        add(new Res_PLCADDRESS("温度模拟量上限", "VW1050", 1, 1));
        add(new Res_PLCADDRESS("温度模拟量下限", "VW1052", 1, 1));
        add(new Res_PLCADDRESS("温度模拟量", "VW1054", 1, 1));
        add(new Res_PLCADDRESS("温度量程上限", "VD1060", 1, 1));
        add(new Res_PLCADDRESS("温度量程下限", "VD1056", 1, 1));

        add(new Res_PLCADDRESS("电流模拟输入量", "-------------", 0, 0));
        add(new Res_PLCADDRESS("电流模拟量上限", "VW1070", 1, 1));
        add(new Res_PLCADDRESS("电流模拟量下限", "VW1072", 1, 1));
        add(new Res_PLCADDRESS("电流模拟量", "VW1074", 1, 1));
        add(new Res_PLCADDRESS("电流量程上限", "VD1080", 1, 1));
        add(new Res_PLCADDRESS("电流量程下限", "VD1076", 1, 1));
        add(new Res_PLCADDRESS("电流报警设置", "VW1092", 1, 1));
        add(new Res_PLCADDRESS("异常加热故障信息", "M42.1", 1, 1));

        //反馈信号
        add(new Res_PLCADDRESS("反馈信号", "-------------", 0, 0));
        add(new Res_PLCADDRESS("初始化完成", "M40.0", 1, 0));
        add(new Res_PLCADDRESS("设备急停", "M40.1", 1, 0));
        add(new Res_PLCADDRESS("原点位反馈", "M40.2", 1, 0));
        add(new Res_PLCADDRESS("抽料位反馈", "M40.3", 1, 0));
        add(new Res_PLCADDRESS("炒菜位1反馈", "M40.4", 1, 0));
        add(new Res_PLCADDRESS("炒菜位2反馈", "M40.5", 1, 0));
        add(new Res_PLCADDRESS("炒菜位3反馈", "M40.6", 1, 0));
        add(new Res_PLCADDRESS("倒菜位反馈", "M40.7", 1, 0));
        add(new Res_PLCADDRESS("投料位反馈", "M41.0", 1, 0));
        add(new Res_PLCADDRESS("清洗位反馈", "M41.1", 1, 0));
        add(new Res_PLCADDRESS("维护位反馈", "M48.0", 1, 0));
        add(new Res_PLCADDRESS("料仓1下料完成", "M41.2", 1, 0));
        add(new Res_PLCADDRESS("料仓2下料完成", "M41.3", 1, 0));
        add(new Res_PLCADDRESS("料仓3下料完成", "M41.4", 1, 0));
        add(new Res_PLCADDRESS("料仓4下料完成", "M42.0", 1, 0));
        add(new Res_PLCADDRESS("炒锅清洗反馈", "M41.5", 1, 0));
        add(new Res_PLCADDRESS("出餐启动反馈", "M41.6", 1, 0));
        add(new Res_PLCADDRESS("炒锅倒菜减速位", "M41.7", 1, 0));
        add(new Res_PLCADDRESS("平移轴在1号位", "M43.0", 1, 0));
        add(new Res_PLCADDRESS("平移轴在2号位", "M43.1", 1, 0));
        add(new Res_PLCADDRESS("平移轴在3号位", "M43.2", 1, 0));
        add(new Res_PLCADDRESS("平移轴在4号位", "M43.3", 1, 0));

        add(new Res_PLCADDRESS("翻转轴1在1号位", "M44.0", 1, 0));
        add(new Res_PLCADDRESS("翻转轴1在2号位", "M44.1", 1, 0));
        add(new Res_PLCADDRESS("翻转轴1在3号位", "M44.2", 1, 0));
        add(new Res_PLCADDRESS("翻转轴1在4号位", "M44.3", 1, 0));
        add(new Res_PLCADDRESS("翻转轴1允许机器人放盒取盒", "M44.4", 1, 0));
        add(new Res_PLCADDRESS("1号位倒菜完成", "M44.7", 1, 0));


        add(new Res_PLCADDRESS("翻转轴2在1号位", "M45.0", 1, 0));
        add(new Res_PLCADDRESS("翻转轴2在2号位", "M45.1", 1, 0));
        add(new Res_PLCADDRESS("翻转轴2在3号位", "M45.2", 1, 0));
        add(new Res_PLCADDRESS("翻转轴2在4号位", "M45.3", 1, 0));
        add(new Res_PLCADDRESS("翻转轴2允许机器人放盒取盒", "M45.4", 1, 0));
        add(new Res_PLCADDRESS("2号位倒菜完成", "M45.7", 1, 0));

        add(new Res_PLCADDRESS("心跳位", "VW1000", 0, 1));

        //检测信号
        add(new Res_PLCADDRESS("监测信号", "-------------", 0, 0));
        add(new Res_PLCADDRESS("当前锅底温度", "VD300", 1, 0));
        add(new Res_PLCADDRESS("炒锅搅拌转速", "VD304", 1, 0));
        add(new Res_PLCADDRESS("当前加热档位", "VD308", 1, 0));
        add(new Res_PLCADDRESS("炒锅当前电压", "VD312", 1, 0));
        add(new Res_PLCADDRESS("炒锅当前电流", "VD316", 1, 0));
        add(new Res_PLCADDRESS("炒锅当前功率", "VD320", 1, 0));
        add(new Res_PLCADDRESS("搅拌频率", "VW324", 1, 0));
        add(new Res_PLCADDRESS("搅拌电机电流", "VW326", 1, 0));
        add(new Res_PLCADDRESS("搅拌电机电压", "VW328", 1, 0));
        add(new Res_PLCADDRESS("搅拌变频器温度", "VW330", 1, 0));
        add(new Res_PLCADDRESS("翻转频率", "VW332", 1, 0));
        add(new Res_PLCADDRESS("翻转电机电流", "VW334", 1, 0));
        add(new Res_PLCADDRESS("翻转电机电压", "VW336", 1, 0));
        add(new Res_PLCADDRESS("翻转变频器温度", "VW338", 1, 0));
        add(new Res_PLCADDRESS("编码器当前位值", "VD340", 1, 0));

        //状态上报
        add(new Res_PLCADDRESS("状态上报", "-------------", 0, 0));
        add(new Res_PLCADDRESS("搅拌电机", "VW350", 1, 0));
        add(new Res_PLCADDRESS("翻转电机", "VW352", 1, 0));
        add(new Res_PLCADDRESS("炒锅", "VW354", 1, 0));

    }};
    /**
     * 一拖四工序模型
     */
    public List<ProcessT> Process_一拖四 = new ArrayList<ProcessT>() {{
        add(new ProcessT("搅拌", Arrays.asList("搅拌速度", "延迟(秒)")));
        add(new ProcessT("位置", Arrays.asList("转动速度", "位置动作", "延迟(秒)")));
        add(new ProcessT("加热", Arrays.asList("加热功率", "延迟(秒)")));
        add(new ProcessT("主料", Arrays.asList("主料名称", "主料位置", "主料重量", "投料动作","炒制位置","烹饪(秒)")));//
        add(new ProcessT("辅料", Arrays.asList("辅料名称", "炒制位置","烹饪(秒)")));
        add(new ProcessT("液体料", new ArrayList<>()));
        add(new ProcessT("并行出料", Arrays.asList("出料克数","等待(秒)")));
        add(new ProcessT("延迟", Arrays.asList("延迟(秒)")));
        add(new ProcessT("出菜", Arrays.asList("等待(秒)")));
        add(new ProcessT("清洗", Arrays.asList("清洗方式","抽水量","等待(秒)")));
    }};
    /**
     * 一拖四工序模型
     */
    public List<ProcessT> Process_一拖二 = new ArrayList<ProcessT>() {{
        add(new ProcessT("搅拌", Arrays.asList("搅拌速度", "延迟(秒)")));
        add(new ProcessT("位置", Arrays.asList("转动速度", "位置动作", "延迟(秒)")));
        add(new ProcessT("加热", Arrays.asList("加热功率", "延迟(秒)")));
        add(new ProcessT("主料", Arrays.asList("主料名称","炒制位置","烹饪(秒)")));//, "主料位置", "主料重量", "投料动作"
        add(new ProcessT("辅料", Arrays.asList("辅料名称", "炒制位置","烹饪(秒)")));
        add(new ProcessT("液体料", new ArrayList<>()));
        add(new ProcessT("并行出料", Arrays.asList("出料克数","等待(秒)")));
        add(new ProcessT("延迟", Arrays.asList("延迟(秒)")));
        add(new ProcessT("出菜", Arrays.asList("等待(秒)")));
        add(new ProcessT("清洗", Arrays.asList("清洗方式","抽水量","等待(秒)")));
    }};

    /**
     * 大炒自动投料基础PLC模型
     */
    public List<Res_PLCADDRESS> PlcAddress_大炒自动投料 = new ArrayList<Res_PLCADDRESS>() {{

        //硬件设备 初始化
        add(new Res_PLCADDRESS("硬件设备", "-------------", 0, 0));
        add(new Res_PLCADDRESS("初始化", "M10.0", 1, 1));
        add(new Res_PLCADDRESS("停止", "M10.1", 1, 1));
        add(new Res_PLCADDRESS("复位", "M10.2", 0, 1));

        //搅拌模型
        add(new Res_PLCADDRESS("模型控制", "-------------", 0, 0));
        add(new Res_PLCADDRESS("搅拌", "M10.3", 1, 1));
        add(new Res_PLCADDRESS("搅拌速度", "VW102", 1, 1));

        //翻转正转模型
        add(new Res_PLCADDRESS("翻转正转", "M10.4", 0, 1));
        add(new Res_PLCADDRESS("翻转反转", "M10.5", 0, 1));
        add(new Res_PLCADDRESS("转动速度", "VW104", 1, 1));


        //加热模型
        add(new Res_PLCADDRESS("加热", "M10.6", 0, 1));
        add(new Res_PLCADDRESS("加热功率", "VW100", 1, 1));
        add(new Res_PLCADDRESS("温控开关", "M17.6", 1, 1));
        add(new Res_PLCADDRESS("暂停开关", "M17.7", 1, 1));

        //主料
        add(new Res_PLCADDRESS("主料", "M17.4", 0, 1));

        //抽水放水
        add(new Res_PLCADDRESS("炒锅抽水", "M10.7", 0, 1));
        add(new Res_PLCADDRESS("炒锅放水", "M11.0", 0, 1));


        //出菜模型
        add(new Res_PLCADDRESS("出菜", "M11.5", 0, 1));


        //位置动作
        add(new Res_PLCADDRESS("原点位", "M11.4", 0, 1));
        add(new Res_PLCADDRESS("倒菜位", "M12.7", 0, 1));
        add(new Res_PLCADDRESS("抽料位", "M11.7", 0, 1));
        add(new Res_PLCADDRESS("清洗位", "M13.0", 0, 1));
        add(new Res_PLCADDRESS("维护位", "M20.0", 0, 1));
        add(new Res_PLCADDRESS("炒菜位1", "M12.0", 0, 1));
        add(new Res_PLCADDRESS("炒菜位2", "M12.1", 0, 1));
        add(new Res_PLCADDRESS("炒菜位3", "M12.2", 0, 1));

        add(new Res_PLCADDRESS("出餐启动", "M11.5", 0, 1));
        add(new Res_PLCADDRESS("炒锅清洗", "M11.6", 0, 1));

        //深度清洗功能
        add(new Res_PLCADDRESS("深度清洗功能", "-------------", 0, 0));
        add(new Res_PLCADDRESS("清洗抽水量", "VW122", 1, 1));
        add(new Res_PLCADDRESS("清洗时间", "VW1150", 1, 1));
        add(new Res_PLCADDRESS("倒水减速角度", "VW1152", 1, 1));
        add(new Res_PLCADDRESS("深度清洗", "M13.6", 0, 1));
        add(new Res_PLCADDRESS("编码器复位", "M13.7", 0, 1));

        //液体料模型
        add(new Res_PLCADDRESS("料仓校准", "-------------", 0, 0));
        add(new Res_PLCADDRESS("校准时间", "VW112", 1, 1));
        add(new Res_PLCADDRESS("料仓1校准开关", "M12.3", 0, 1));
        add(new Res_PLCADDRESS("料仓1校准值", "VW114", 1, 1));
        add(new Res_PLCADDRESS("料仓2校准开关", "M12.4", 0, 1));
        add(new Res_PLCADDRESS("料仓2校准值", "VW116", 1, 1));
        add(new Res_PLCADDRESS("料仓3校准开关", "M12.5", 0, 1));
        add(new Res_PLCADDRESS("料仓3校准值", "VW118", 1, 1));
        add(new Res_PLCADDRESS("料仓4校准开关", "M13.5", 0, 1));
        add(new Res_PLCADDRESS("料仓4校准值", "VW120", 1, 1));
        add(new Res_PLCADDRESS("开始校正", "M12.6", 0, 1));

        add(new Res_PLCADDRESS("料仓自动", "-------------", 0, 0));
        add(new Res_PLCADDRESS("料仓1需求值", "VW106", 1, 1));
        add(new Res_PLCADDRESS("料仓1下料", "M11.1", 0, 1));
        add(new Res_PLCADDRESS("料仓2需求值", "VW108", 1, 1));
        add(new Res_PLCADDRESS("料仓2下料", "M11.2", 0, 1));
        add(new Res_PLCADDRESS("料仓3需求值", "VW110", 1, 1));
        add(new Res_PLCADDRESS("料仓3下料", "M11.3", 0, 1));
        add(new Res_PLCADDRESS("料仓4需求值", "VW122", 1, 1));
        add(new Res_PLCADDRESS("料仓4下料", "M13.4", 0, 1));

        add(new Res_PLCADDRESS("料仓手动", "-------------", 0, 0));
        add(new Res_PLCADDRESS("料仓1手动开关", "M13.1", 1, 1));
        add(new Res_PLCADDRESS("料仓2手动开关", "M13.2", 1, 1));
        add(new Res_PLCADDRESS("料仓3手动开关", "M13.3", 1, 1));
        add(new Res_PLCADDRESS("料仓4手动开关", "M10.7", 1, 1));

        //上下限
        add(new Res_PLCADDRESS("位置上下限", "-------------", 0, 0));
        add(new Res_PLCADDRESS("原点位置下限", "VD150", 1, 1));
        add(new Res_PLCADDRESS("原点位置上限", "VD154", 1, 1));
        add(new Res_PLCADDRESS("维护位置下限", "VD1130", 1, 1));
        add(new Res_PLCADDRESS("维护位置上限", "VD1134", 1, 1));
        add(new Res_PLCADDRESS("洗锅位置下限", "VD158", 1, 1));
        add(new Res_PLCADDRESS("洗锅位置上限", "VD162", 1, 1));
        add(new Res_PLCADDRESS("倒菜位置下限", "VD166", 1, 1));
        add(new Res_PLCADDRESS("倒菜位置上限", "VD170", 1, 1));
        add(new Res_PLCADDRESS("抽调料位置下限", "VD174", 1, 1));
        add(new Res_PLCADDRESS("抽调料位置上限", "VD178", 1, 1));
        add(new Res_PLCADDRESS("1#炒制位置下限", "VD182", 1, 1));
        add(new Res_PLCADDRESS("1#炒制位置上限", "VD186", 1, 1));
        add(new Res_PLCADDRESS("2#炒制位置下限", "VD190", 1, 1));
        add(new Res_PLCADDRESS("2#炒制位置上限", "VD194", 1, 1));
        add(new Res_PLCADDRESS("3#炒制位置下限", "VD198", 1, 1));
        add(new Res_PLCADDRESS("3#炒制位置上限", "VD202", 1, 1));
        add(new Res_PLCADDRESS("炒锅工作范围下限", "VD206", 1, 1));
        add(new Res_PLCADDRESS("炒锅工作范围上限", "VD210", 1, 1));

        //自动投料-平移轴
        add(new Res_PLCADDRESS("平移轴控制", "-------------", 0, 0));
        add(new Res_PLCADDRESS("平移-伺服当前值", "VD220", 1, 1));
        add(new Res_PLCADDRESS("平移-点动速度", "VD224", 1, 1));
        add(new Res_PLCADDRESS("平移-回原点速度", "VD228", 1, 1));
        add(new Res_PLCADDRESS("平移-定位运行速度", "VD232", 1, 1));

        add(new Res_PLCADDRESS("平移-点动正转", "M14.0", 0, 1));
        add(new Res_PLCADDRESS("平移-点动反转", "M14.1", 0, 1));
        add(new Res_PLCADDRESS("平移-回原点", "M14.2", 0, 1));
        add(new Res_PLCADDRESS("平移-去1号位", "M14.3", 0, 1));
        add(new Res_PLCADDRESS("平移-去2号位", "M14.4", 0, 1));
        add(new Res_PLCADDRESS("平移-去3号位", "M14.5", 0, 1));
        add(new Res_PLCADDRESS("平移-去4号位", "M14.6", 0, 1));

        add(new Res_PLCADDRESS("平移-1号位置值", "VD236", 1, 1));
        add(new Res_PLCADDRESS("平移-1#位置设定", "M15.0", 0, 1));
        add(new Res_PLCADDRESS("平移-2号位置值", "VD240", 1, 1));
        add(new Res_PLCADDRESS("平移-2#位置设定", "M15.1", 0, 1));
        add(new Res_PLCADDRESS("平移-3号位置值", "VD244", 1, 1));
        add(new Res_PLCADDRESS("平移-3#位置设定", "M15.2", 0, 1));
        add(new Res_PLCADDRESS("平移-4号位置值", "VD248", 1, 1));
        add(new Res_PLCADDRESS("平移-4#位置设定", "M15.3", 0, 1));

        //自动投料-翻转轴
        add(new Res_PLCADDRESS("翻转轴控制", "-------------", 0, 0));
        add(new Res_PLCADDRESS("翻转-伺服当前值", "VD260", 1, 1));
        add(new Res_PLCADDRESS("翻转-点动速度", "VD264", 1, 1));
        add(new Res_PLCADDRESS("翻转-回原点速度", "VD268", 1, 1));
        add(new Res_PLCADDRESS("翻转-定位运行速度", "VD272", 1, 1));

        add(new Res_PLCADDRESS("翻转-点动正转", "M16.0", 0, 1));
        add(new Res_PLCADDRESS("翻转-点动反转", "M16.1", 0, 1));
        add(new Res_PLCADDRESS("翻转-回原点", "M16.2", 0, 1));
        add(new Res_PLCADDRESS("翻转-去1号位", "M16.3", 0, 1));
        add(new Res_PLCADDRESS("翻转-去2号位", "M16.4", 0, 1));
        add(new Res_PLCADDRESS("翻转-去3号位", "M16.5", 0, 1));
        add(new Res_PLCADDRESS("翻转-去4号位", "M16.6", 0, 1));

        add(new Res_PLCADDRESS("翻转-去1号吸料位", "M16.6", 0, 1));
        add(new Res_PLCADDRESS("翻转-去2号吸料位", "M70.5", 0, 1));
        add(new Res_PLCADDRESS("翻转-去3号吸料位", "M70.6", 0, 1));
        add(new Res_PLCADDRESS("翻转-去4号吸料位", "M70.7", 0, 1));


        add(new Res_PLCADDRESS("翻转-1号位置值", "VD276", 1, 1));
        add(new Res_PLCADDRESS("翻转-1#位置设定", "M17.0", 0, 1));
        add(new Res_PLCADDRESS("翻转-2号位置值", "VD280", 1, 1));
        add(new Res_PLCADDRESS("翻转-2#位置设定", "M17.1", 0, 1));
        add(new Res_PLCADDRESS("翻转-3号位置值", "VD284", 1, 1));
        add(new Res_PLCADDRESS("翻转-3#位置设定", "M17.2", 0, 1));
        add(new Res_PLCADDRESS("翻转-4号位置值", "VD288", 1, 1));
        add(new Res_PLCADDRESS("翻转-4#位置设定", "M17.3", 0, 1));
        add(new Res_PLCADDRESS("翻转-1号吸料位置值", "VD288", 1, 1));
        add(new Res_PLCADDRESS("翻转-1#吸料位置设定", "M17.3", 0, 1));
        add(new Res_PLCADDRESS("翻转-2号吸料位置值", "VD138", 1, 1));
        add(new Res_PLCADDRESS("翻转-2#吸料位置设定", "M70.0", 0, 1));
        add(new Res_PLCADDRESS("翻转-3号吸料位置值", "VD142", 1, 1));
        add(new Res_PLCADDRESS("翻转-3#吸料位置设定", "M70.1", 0, 1));
        add(new Res_PLCADDRESS("翻转-4号吸料位置值", "VD146", 1, 1));
        add(new Res_PLCADDRESS("翻转-4#吸料位置设定", "M70.2", 0, 1));

        add(new Res_PLCADDRESS("倒菜启动", "M17.4", 0, 1));
        add(new Res_PLCADDRESS("磁铁吸合", "M17.5", 0, 1));

        //反馈信号
        add(new Res_PLCADDRESS("反馈信号", "-------------", 0, 0));
        add(new Res_PLCADDRESS("初始化完成", "M40.0", 1, 0));
        add(new Res_PLCADDRESS("设备急停", "M40.1", 1, 0));
        add(new Res_PLCADDRESS("原点位反馈", "M40.2", 1, 0));
        add(new Res_PLCADDRESS("抽料位反馈", "M40.3", 1, 0));
        add(new Res_PLCADDRESS("维护位反馈", "M48.0", 1, 0));
        add(new Res_PLCADDRESS("炒菜位1反馈", "M40.4", 1, 0));
        add(new Res_PLCADDRESS("炒菜位2反馈", "M40.5", 1, 0));
        add(new Res_PLCADDRESS("炒菜位3反馈", "M40.6", 1, 0));
        add(new Res_PLCADDRESS("倒菜位反馈", "M40.7", 1, 0));
        add(new Res_PLCADDRESS("投料位反馈", "M41.0", 1, 0));
        add(new Res_PLCADDRESS("清洗位反馈", "M41.1", 1, 0));
        add(new Res_PLCADDRESS("料仓1下料完成", "M41.2", 1, 0));
        add(new Res_PLCADDRESS("料仓2下料完成", "M41.3", 1, 0));
        add(new Res_PLCADDRESS("料仓3下料完成", "M41.4", 1, 0));
        add(new Res_PLCADDRESS("料仓4下料完成", "M42.0", 1, 0));
        add(new Res_PLCADDRESS("炒锅清洗反馈", "M41.5", 1, 0));
        add(new Res_PLCADDRESS("出餐启动反馈", "M41.6", 1, 0));
        add(new Res_PLCADDRESS("炒锅倒菜减速位", "M41.7", 1, 0));
        add(new Res_PLCADDRESS("平移轴在1号位", "M43.0", 1, 0));
        add(new Res_PLCADDRESS("平移轴在2号位", "M43.1", 1, 0));
        add(new Res_PLCADDRESS("平移轴在3号位", "M43.2", 1, 0));
        add(new Res_PLCADDRESS("平移轴在4号位", "M43.3", 1, 0));
        add(new Res_PLCADDRESS("翻转轴在1号位", "M44.0", 1, 0));
        add(new Res_PLCADDRESS("翻转轴在2号位", "M44.1", 1, 0));
        add(new Res_PLCADDRESS("翻转轴在3号位", "M44.2", 1, 0));
        add(new Res_PLCADDRESS("翻转轴在4号位", "M44.3", 1, 0));
        add(new Res_PLCADDRESS("翻转轴在1号吸料位", "M44.3", 1, 0));
        add(new Res_PLCADDRESS("翻转轴在2号吸料位", "M72.0", 1, 0));
        add(new Res_PLCADDRESS("翻转轴在3号吸料位", "M72.1", 1, 0));
        add(new Res_PLCADDRESS("翻转轴在4号吸料位", "M72.2", 1, 0));

        add(new Res_PLCADDRESS("倒菜完成", "M44.4", 1, 0));
        add(new Res_PLCADDRESS("心跳位", "VW1000", 0, 1));

        add(new Res_PLCADDRESS("温度模拟输入量", "-------------", 0, 0));
        add(new Res_PLCADDRESS("温度模拟量上限", "VW1050", 1, 1));
        add(new Res_PLCADDRESS("温度模拟量下限", "VW1052", 1, 1));
        add(new Res_PLCADDRESS("温度模拟量", "VW1054", 1, 1));
        add(new Res_PLCADDRESS("温度量程上限", "VD1060", 1, 1));
        add(new Res_PLCADDRESS("温度量程下限", "VD1056", 1, 1));

        add(new Res_PLCADDRESS("电流模拟输入量", "-------------", 0, 0));
        add(new Res_PLCADDRESS("电流模拟量上限", "VW1070", 1, 1));
        add(new Res_PLCADDRESS("电流模拟量下限", "VW1072", 1, 1));
        add(new Res_PLCADDRESS("电流模拟量", "VW1074", 1, 1));
        add(new Res_PLCADDRESS("电流量程上限", "VD1080", 1, 1));
        add(new Res_PLCADDRESS("电流量程下限", "VD1076", 1, 1));
        add(new Res_PLCADDRESS("电流报警设置", "VW1092", 1, 1));
        add(new Res_PLCADDRESS("异常加热故障信息", "M42.1", 1, 1));

        //检测信号
        add(new Res_PLCADDRESS("监测信号", "-------------", 0, 0));
        add(new Res_PLCADDRESS("当前锅底温度", "VD300", 1, 0));
        add(new Res_PLCADDRESS("炒锅搅拌转速", "VD304", 1, 0));
        add(new Res_PLCADDRESS("当前加热档位", "VD308", 1, 0));
        add(new Res_PLCADDRESS("炒锅当前电压", "VD312", 1, 0));
        add(new Res_PLCADDRESS("炒锅当前电流", "VD316", 1, 0));
        add(new Res_PLCADDRESS("炒锅当前功率", "VD320", 1, 0));
        add(new Res_PLCADDRESS("搅拌频率", "VW324", 1, 0));
        add(new Res_PLCADDRESS("搅拌电机电流", "VW326", 1, 0));
        add(new Res_PLCADDRESS("搅拌电机电压", "VW328", 1, 0));
        add(new Res_PLCADDRESS("搅拌变频器温度", "VW330", 1, 0));
        add(new Res_PLCADDRESS("翻转频率", "VW332", 1, 0));
        add(new Res_PLCADDRESS("翻转电机电流", "VW334", 1, 0));
        add(new Res_PLCADDRESS("翻转电机电压", "VW336", 1, 0));
        add(new Res_PLCADDRESS("翻转变频器温度", "VW338", 1, 0));
        add(new Res_PLCADDRESS("编码器当前位值", "VD340", 1, 0));

        //状态上报
        add(new Res_PLCADDRESS("状态上报", "-------------", 0, 0));
        add(new Res_PLCADDRESS("搅拌电机", "VW350", 1, 0));
        add(new Res_PLCADDRESS("翻转电机", "VW352", 1, 0));
        add(new Res_PLCADDRESS("炒锅", "VW354", 1, 0));
    }};

    /**
     * Bottom 按钮
     */
    public List<String> BottomList = new ArrayList<String>() {{
        add("初始化");
        add("停止");
        add("复位");


        add("主料");
        add("出菜");
        add("原点位");
        add("维护位");
        add("投料位");
        add("倒菜位");
        add("抽料位");
        add("清洗位");
        add("炒菜位1");
        add("炒菜位2");
        add("炒菜位3");
        add("出餐启动");
        add("出餐启动");

        add("开始校正");
        add("料仓1下料");
        add("料仓2下料");
        add("料仓3下料");


        add("平移-回原点");
        add("平移-去1号位");
        add("平移-去2号位");
        add("平移-去3号位");
        add("平移-去4号位");

        add("平移-1#位置设定");
        add("平移-2#位置设定");
        add("平移-3#位置设定");
        add("平移-4#位置设定");

        add("翻转-回原点");
        add("翻转-去1号位");
        add("翻转-去2号位");
        add("翻转-去3号位");
        add("翻转-去4号位");

        add("翻转-1#位置设定");
        add("翻转-2#位置设定");
        add("翻转-3#位置设定");
        add("翻转-4#位置设定");
        add("倒菜启动");
        //add("磁铁吸合");
    }};
    //endregion

    //region 云端数据
    /**
     * 云端数据
     */
    public ResALLData cloudData = null;
    /**
     * 云端商品
     */
    public List<CloudGood> cloudGoods = new ArrayList<>();
    //endregion

    //region 选配版本信息
    /**
     * 版本信息
     */
    public String[] versionSelectionValues = new String[]{"一拖四", "一拖二"};

    /**
     * 选配版本信息
     */
    public String versionSelectionEnum = "一拖四";
    //endregion

    //region 主页
    /**
     * 主页流
     */
    public FragmentAdapter fragmentAdapter = null;
    //endregion

    //region 是否自动加热
    /**
     * 是否自动加热(水池)
     */
    public Boolean AutomaticHeating=false;
    /**
     * 果糖1
     */
    public Boolean GT1_AutomaticHeating=false;
    /**
     * 果糖2
     */
    public Boolean GT2_AutomaticHeating=false;
    //endregion

    //region 是否自动补水
    /**
     * 是否自动补水(水池)
     */
    public Boolean AutomaticWaterRefill=false;
    /**
     * 自动补水延迟时间
     */
    public String AutomaticWaterRefillTime="0.0";
    //endregion


    /**
     * 根据名称获取变量
     *
     * @param item
     * @return
     */
    public String GetProcessTypeVal(String item) {
        String data = "";
        if (item.equals("搅拌动作")) {
            data = "正转反转、一直正转、一直反转";
        } else if (item.equals("位置动作")) {
            data = "原点位、出餐启动、倒菜位、抽料位、清洗位、炒菜位1、炒菜位2、炒菜位3";
        } else if (item.equals("炒制位置")) {
            data = "炒菜位1、炒菜位2、炒菜位3、原点位";
        }else if (item.equals("投料动作")) {
            //data = "投出抖动三次、投出等待三秒、直接投出、手动投料";
            data = "投出等待三秒、直接投出、手动投料";
        }else if (item.equals("清洗方式")) {
            data = "一般清洗、深度清洗";
        }
        else if (item.equals("主料位置")) {
            data = "1号位、2号位、3号位、4号位";
        } else if (item.equals("正转速度") || item.equals("反转速度") || item.equals("转动速度") || item.equals("搅拌速度")) {
            data = "停止、最低、低速、中速、高速、最高、极高";
        } else if (item.equals("加热功率") || item.equals("热锅功率")) {
            data = "停止、一档、二档、三档、四档、五档、六档、七档、八档";
        }
        return data;
    }
}
