package com.bonait.bnframework.common.helper;

import android.util.Log;

import com.bonait.bnframework.common.helper.I.IRunT;
import com.bonait.bnframework.common.helper.I.IThread;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.Inet6Address;
import java.net.InetAddress;
import java.net.NetworkInterface;
import java.net.Socket;
import java.net.SocketException;
import java.util.Enumeration;

public class TcpClient {
    private Socket socket;
    public IRunT<String> ReceiveMsg;
    public String IpAddress;
    public int Port=40000;
    public TcpClient(String ip,int port){
        IpAddress=ip;
        Port=port;
    }

    /**
     * 获取ip地址
     * @return
     */
    public  String getHostIP() {
        String hostIp = null;
        try {
            Enumeration nis = NetworkInterface.getNetworkInterfaces();
            InetAddress ia = null;
            while (nis.hasMoreElements()) {
                NetworkInterface ni = (NetworkInterface) nis.nextElement();
                Enumeration<InetAddress> ias = ni.getInetAddresses();
                while (ias.hasMoreElements()) {
                    ia = ias.nextElement();
                    if (ia instanceof Inet6Address) {
                        continue;// skip ipv6
                    }
                    String ip = ia.getHostAddress();
                    if (!"127.0.0.1".equals(ip)) {
                        hostIp = ia.getHostAddress();
                        break;
                    }
                }
            }
        } catch (SocketException e) {
            Log.i("yao", "SocketException");
            e.printStackTrace();
        }
        return hostIp;
    }

    public TcpClient(){
        IpAddress=getHostIP();
    }

    public void Connect(){
        new Thread(()->{
            try{
                socket = new Socket(IpAddress,Port);
                while(!socket.isConnected()){
                    Thread.sleep(1000);
                    socket = new Socket(IpAddress,Port);
                }
                MessageLog.ShowInfo("TcpClient连接成功");
                ThreadManager.Get().StartLong("TCP客户端监听", true, new IThread() {
                    @Override
                    public void Run() throws Exception {
                        if(CheckConnect()){
                            try{
                                BufferedReader in=new BufferedReader(new InputStreamReader(socket.getInputStream()));
//                                char[] buffer = new char[1024];
//                                int len=  in.read(buffer);
                                String str= in.readLine();
//                                int len = socket.getInputStream().read(buffer);
//                                String str = new String(buffer,"UTF-8");
                                if(ReceiveMsg!=null)ReceiveMsg.Run(str);
                                MessageLog.ShowInfo(str);

//                                if(socket.getInputStream().available()>0){
//                                    byte[] buffer = new byte[socket.getInputStream().available()];
//                                    int len = socket.getInputStream().read(buffer);
//                                    String str = new String(buffer,"UTF-8");
//                                    if(ReceiveMsg!=null)ReceiveMsg.Run(str);
//                                    MessageLog.ShowInfo(str);
//                                }
                            }catch  (Exception e){MessageLog.ShowInfo("错误1："+e.getMessage());}
                        }
                        Thread.sleep(1);
                    }

                    @Override
                    public void RunComplete() throws Exception {

                    }
                });
            }catch  (Exception e){
                MessageLog.ShowInfo("错误2："+e.getMessage());
            }

        }).start();
    }

    private boolean CheckConnect(){
        if(socket!=null&&socket.isConnected())return true;
        try{
            socket = new Socket(IpAddress,Port);
            while(!socket.isConnected()){
                Thread.sleep(1000);
                socket = new Socket(IpAddress,Port);
            }
        }catch(Exception e){MessageLog.ShowInfo("错误3："+e.getMessage());}
        return true;
    }

}
