package com.bonait.bnframework.deviceBusiness;

public class DeviceAddManager {

    /**
     * 心跳地址
     */
    public static String Heartbeat="D0";

    /**
     * 获取外置仓正转地址
     * @param ，外置仓编号 1-6
     * @return
     */
    public static String GetExternalForward(int num){
        //D1--D6
        if (num<=0||num>6) return "";
        return "D"+num;
    }

    /**
     * 获取外置仓反转地址
     * @param ，外置仓编号，1-6
     * @return
     */
    public static String GetExternalReversal(int num){
        //D9--D14
        if (num<=0||num>6) return "";
        return "D"+num+8;
    }

    /**
     * 获取加热仓正转地址
     * @param ，加热仓编号，1-2
     * @return
     */
    public static String GetHeatForward(int num){
        //D7--D8
        if (num<=0||num>2) return "";
        return "D"+num+6;
    }

    /**
     * 获取加热仓反转地址
     * @param ，加热仓编号，1-2
     * @return
     */
    public static String GetHeatReversal(int num){
        //D15--D16
        if (num<=0||num>2) return "";
        return "D"+num+14;
    }

    /**
     * 获取粉料仓地址
     * @param ，粉料仓编号，1-6
     * @return
     */
    public static String GetPowder(int num){
        //D17--D22
        if (num<=0||num>6) return "";
        return "D"+num+16;
    }

    /**
     * 获取液体仓地址
     * @param ，液体仓编号，1-2
     * @return
     */
    public static String GetLiquid(int num){
        //D23--D24
        if (num<=0||num>2) return "";
        return "D"+num+22;
    }

    /**
     * 获取加热仓管道地址
     * @param ，加热仓管道编号，1-2
     * @return
     */
    public static String GetHeatPiping(int num){
        //D42--D43
        if (num<=0||num>2) return "";
        return "D"+num+41;
    }

    /**
     * 进水阀地址
     */
    public static String InletValve="D40";

    /**
     * 排水阀地址
     */
    public static String DrainValve="D41";

    /**
     * 三色红灯
     */
    public static  String RedLight="D44";

    /**
     * 三色绿灯
     */
    public static String GreenLight="D45";

    /**
     * 三色黄灯
     */
    public static String YellowLight="D46";

    /**
     * 清洗加热
     */
    public static String CleanHeat="D47";

}
