package com.bonait.bnframework.dialog;

import android.app.Activity;
import android.content.Context;
import android.content.ContextWrapper;
import android.view.Gravity;
import android.view.View;

import androidx.annotation.NonNull;

import com.bonait.bnframework.R;
import com.bonait.bnframework.common.db.res.UserLogEnum;
import com.bonait.bnframework.common.helper.MessageLog;


public class DialogManager {
    private static volatile DialogManager mInstance = null;

    private DialogManager() {

    }

    public static DialogManager getInstance() {
        if (mInstance == null) {
            synchronized (DialogManager.class) {
                if (mInstance == null) {
                    mInstance = new DialogManager();
                }
            }
        }
        return mInstance;
    }
    public Activity activityMain=null;
    public DialogView initView(Context context, int layout) {
        return new DialogView(context, layout, R.style.CustomDialog, Gravity.CENTER);
    }

    public DialogView initView(Context context, int layout, int gravity,Activity activity) {
        activityMain=activity;
        return new DialogView(context, layout, R.style.mydialog, gravity);
    }
    // 显示弹框
    public void show(DialogView view) {
        if (view != null) {
            if (!view.isShowing()) {
                view.show();
            }
        }
    }

    // 显示弹框
    public void show(DialogView view, int closeId) {
        if (view != null) {
            if (!view.isShowing()) {
                if (!view.findViewById(closeId).hasOnClickListeners()) {
                    view.findViewById(closeId).setOnClickListener(new View.OnClickListener() {
                        @Override
                        public void onClick(View view1) {
                            hide(view);
                        }
                    });
                }
                if (activityMain!=null && !activityMain.isFinishing()) {
                    view.show();
                }
                else
                {
                    MessageLog.ShowUserMessage( UserLogEnum.订单处理日志 ,"弹框Active获取失败");
                }
            }
        }
    }

    // 隐藏弹框
    public void hide(DialogView view) {
        if (view != null) {
            if (view.isShowing()) {
                view.dismiss();
            }
        }
    }
}

