package com.bonait.bnframework.modules.home.activity;

import androidx.fragment.app.Fragment;
import androidx.viewpager.widget.ViewPager;

import android.app.Activity;
import android.content.Context;
import android.net.wifi.p2p.WifiP2pConfig;
import android.net.wifi.p2p.WifiP2pGroup;
import android.net.wifi.p2p.WifiP2pManager;
import android.net.wifi.p2p.WifiP2pManager.Channel;
import android.os.Bundle;
import android.util.Log;

import com.bonait.bnframework.HBL.Dialog.AlertDialogButton;
import com.bonait.bnframework.HBL.Dialog.DialogHelper;
import com.bonait.bnframework.HBL.HttpServer;
import com.bonait.bnframework.HBL.Task;
import com.bonait.bnframework.R;
import com.bonait.bnframework.business.ConfigData;
import com.bonait.bnframework.business.DoubleFryingpanControl;
import com.bonait.bnframework.business.FryingpanModbusHelper;
import com.bonait.bnframework.business.OrderServer;
import com.bonait.bnframework.business.PeripheralData;
import com.bonait.bnframework.business.RobotControl;
import com.bonait.bnframework.business.RobotData;
import com.bonait.bnframework.business.YJDeviceHelper;
import com.bonait.bnframework.common.ModbusSlave.ModbusTcpSlave;
import com.bonait.bnframework.common.base.BaseActivity;
import com.bonait.bnframework.common.constant.ConfigName;
import com.bonait.bnframework.common.constant.MessageName;
import com.bonait.bnframework.common.db.QueryDB;
import com.bonait.bnframework.common.db.mode.BPA_GOODS;
import com.bonait.bnframework.common.db.mode.BPA_GOODSRECIPE;
import com.bonait.bnframework.common.helper.I.IRunT;
import com.bonait.bnframework.common.helper.MQTT;
import com.bonait.bnframework.common.helper.MediaPlayerHelper;
import com.bonait.bnframework.common.helper.MessageLog;
import com.bonait.bnframework.common.helper.TcpClient;
import com.bonait.bnframework.common.helper.TcpServer;
import com.bonait.bnframework.common.http.callback.json.JsonDialogCallback;
import com.bonait.bnframework.common.message.MessageManager;
import com.bonait.bnframework.common.modbus.IOperateResult;
import com.bonait.bnframework.common.modbus.ModbusMaster;
import com.bonait.bnframework.common.model.ResAPI;
import com.bonait.bnframework.common.model.mode.ActionJsonMode;
import com.bonait.bnframework.common.model.mode.BatchingInfo;
import com.bonait.bnframework.common.model.mode.BomTechnologyActionInfo;
import com.bonait.bnframework.common.model.mode.CloudGood;
import com.bonait.bnframework.common.model.mode.GoodsTechnology;
import com.bonait.bnframework.common.model.mode.TechnologyAction;
import com.bonait.bnframework.common.model.mode.UpdateBomInfo;
import com.bonait.bnframework.common.model.mode.UpdateCloudGood;
import com.bonait.bnframework.common.oss.OssHelper;
import com.bonait.bnframework.common.tabbar.MainNavigateTabBar;
import com.bonait.bnframework.common.utils.NetworkUtils;
import com.bonait.bnframework.common.utils.ToastUtils;
import com.bonait.bnframework.common.view.GoodEditDialog;
import com.bonait.bnframework.modules.home.adapter.FragmentAdapter;
import com.bonait.bnframework.modules.home.fragment.DingDanfragment;
import com.bonait.bnframework.modules.home.fragment.DoubleFryingpanFragment;
import com.bonait.bnframework.modules.home.fragment.GongnengFragment;
import com.bonait.bnframework.modules.home.fragment.RobotMain;
import com.bonait.bnframework.modules.home.fragment.SheZhifragment;
import com.bonait.bnframework.modules.mine.fragment.MyFragment;
import com.google.gson.Gson;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.HttpHeaders;
import com.lzy.okgo.model.Response;
import com.qmuiteam.qmui.widget.QMUIViewPager;

import java.net.InetAddress;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import okhttp3.MediaType;
import okhttp3.RequestBody;

public class BottomNavigationMainActivity extends BaseActivity {

    @BindView(R.id.mainTabBar)
    MainNavigateTabBar mNavigateTabBar;

    @BindView(R.id.viewpager)
    QMUIViewPager viewPager;
    Context context;
    Activity activity;
    HttpServer hs;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_bottom_navigation_main);
        context=this;
        activity=this;
        try {
            ButterKnife.bind(this);
            MediaPlayerHelper.getInstance().SetConText(getBaseContext());
            mNavigateTabBar.onRestoreInstanceState(savedInstanceState);
            mNavigateTabBar.addTab(null, new MainNavigateTabBar.TabParam(R.mipmap.gongneng, R.mipmap.gongneng_selected, "功能"));
            mNavigateTabBar.addTab(null, new MainNavigateTabBar.TabParam(0, 0, ""));
            mNavigateTabBar.addTab(null, new MainNavigateTabBar.TabParam(R.mipmap.shezhi, R.mipmap.shezhi_selected, "设置"));
            mNavigateTabBar.setTabSelectListener(mOnNavigationItemSelectedListener);
            initFragment();
            Init();
        }
        catch (Exception e){
            Log.i("TAG", "onCreate: "+e.getMessage());
        }
    }


    @Override
    protected void onDestroy() {
        FryingpanModbusHelper.getInstance().Dispose();
        YJDeviceHelper.getInstance().Close();
        if(hs!=null)
            hs.stop();
        //关闭PLC连接
        ConfigData.getInstance().ColsePLC();
        MediaPlayerHelper.getInstance().Release();
        MQTT.get().ConnMqttBroken(false);//释放mqtt
        super.onDestroy();
    }

    private List<Fragment> fragmentList = new ArrayList<Fragment>();

    /**
     * viewPager里添加fragment
     */
    private void initFragment() {
        fragmentList = new ArrayList<>();
        fragmentList.add(new GongnengFragment());
        if(ConfigName.getInstance().versionSelectionEnum.equals("一拖四")){
            fragmentList.add(new RobotMain());
        }
        else if (ConfigName.getInstance().versionSelectionEnum.equals("一拖二")){
            fragmentList.add(new DoubleFryingpanFragment());
            hs = new HttpServer();
        }

        fragmentList.add(new SheZhifragment());
        ConfigName.getInstance().fragmentAdapter = new FragmentAdapter(getSupportFragmentManager(), fragmentList);
        viewPager.setAdapter(ConfigName.getInstance().fragmentAdapter);
        ConfigName.getInstance().fragmentAdapter.SetViewPage(viewPager);
        //手指滑动
        viewPager.addOnPageChangeListener(pageChangeListener);
        // 设置viewPager缓存多少个fragment
        viewPager.setOffscreenPageLimit(3);
        // 再来一单
        viewPager.setCurrentItem(1);
        viewPager.setSwipeable(false);//禁用页面滑动功能
    }

    /**
     * 初始化
     */
    public void Init() {
        //1.同步时间
        NetworkUtils.SynchronizationTime();
        //判断连接环境
        ConfigData.getInstance().ToggleEnvironment();

        if(ConfigName.getInstance().versionSelectionEnum.equals("一拖四")){
            RobotControl.getInstance().Init();
        }
        else if (ConfigName.getInstance().versionSelectionEnum.equals("一拖二")){
            DoubleFryingpanControl.getInstance().Init();
            PeripheralData.ConveyorLineOutputBowl.ChangeNotify=(s)->{
                if( PeripheralData.PutBlowComplete){
                    DialogHelper.showInfo(this,"餐盆到位，请出餐！", AlertDialogButton.OK,null);
                    PeripheralData.PutBlowComplete=false;
                    Task.Run(()->{
                        Task.Delay(3000);
                        YJDeviceHelper.getInstance().ConveyorLineControl(false);
                    });
                }
            };

            RobotData.EStop.ChangeNotify=(s)->{
               if(s) DialogHelper.showError(this,"机器人急停中！", AlertDialogButton.OK,null);
            };
//            RobotData.Grating.ChangeNotify=(s)->{
//                DialogHelper.showError(this,"机器人急停中！", AlertDialogButton.OK,null);
//            };
        }
    }

    /**
     * 配置bottom底部菜单栏监听器，手指点击底部菜单监听
     */
    private MainNavigateTabBar.OnTabSelectedListener mOnNavigationItemSelectedListener
            = new MainNavigateTabBar.OnTabSelectedListener() {
        @Override
        public void onTabSelected(MainNavigateTabBar.ViewHolder holder) {
            int _postion = 0;
            switch (holder.tag) {
                case "功能":
                    _postion = 0;
                    break;
                case "设置":
                    _postion =2;
                    break;
                case "":
                    _postion = 1;
                    if(ConfigName.getInstance().IsChangeGoods) {
                        ConfigData.getInstance().DownDataToDevice(context,activity);
                    }
                    break;
            }
            viewPager.setCurrentItem(_postion);
        }
    };
    /**
     * 配置ViewPager监听器，手指滑动监听
     */
    private ViewPager.OnPageChangeListener pageChangeListener = new ViewPager.OnPageChangeListener() {
        @Override
        public void onPageScrolled(int position, float positionOffset, int positionOffsetPixels) {
        }

        @Override
        public void onPageSelected(int position) {
            mNavigateTabBar.setCurrentSelectedTab(position);
        }

        @Override
        public void onPageScrollStateChanged(int state) {
        }
    };








}