package com.bonait.bnframework.modules.home.fragment;

import android.annotation.SuppressLint;
import android.graphics.Color;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.bonait.bnframework.R;
import com.bonait.bnframework.business.ConfigData;
import com.bonait.bnframework.business.DoubleFryingpanControl;
import com.bonait.bnframework.business.ExecuteTheRecipe;
import com.bonait.bnframework.business.FryingPanPar;
import com.bonait.bnframework.business.ICompleteNotify;
import com.bonait.bnframework.business.IStatusNotify;
import com.bonait.bnframework.business.OrderData;
import com.bonait.bnframework.business.RobotControl;
import com.bonait.bnframework.business.RobotModbus;
import com.bonait.bnframework.common.base.BaseFragment;
import com.bonait.bnframework.common.constant.ConfigName;
import com.bonait.bnframework.common.constant.DataBus;
import com.bonait.bnframework.common.constant.MessageName;
import com.bonait.bnframework.common.db.QueryDB;
import com.bonait.bnframework.common.db.mode.BPA_GOODS;
import com.bonait.bnframework.common.db.mode.BPA_GOODSRECIPE;
import com.bonait.bnframework.common.db.res.ResGoodsMake;
import com.bonait.bnframework.common.helper.I.IRun;
import com.bonait.bnframework.common.helper.I.MyClickListener;
import com.bonait.bnframework.common.linktab.LinkMode;
import com.bonait.bnframework.common.linktab.makegood.MakeGoodLeftAdapter;
import com.bonait.bnframework.common.linktab.makegood.MakeGoodRightAdapter;
import com.bonait.bnframework.common.message.MessageLooper;
import com.bonait.bnframework.common.message.MessageManager;
import com.bonait.bnframework.common.modbus.ModbusMaster;
import com.bonait.bnframework.common.model.mode.CloudGood;
import com.bonait.bnframework.common.utils.AlertDialogUtils;
import com.bonait.bnframework.dialog.DialogManager;
import com.bonait.bnframework.dialog.DialogView;
import com.bonait.bnframework.modules.home.adapter.loadinggood_adapter;
import com.qmuiteam.qmui.widget.QMUITopBarLayout;
import com.qmuiteam.qmui.widget.dialog.QMUIDialog;
import com.qmuiteam.qmui.widget.dialog.QMUIDialogAction;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;

public class RobotMain extends BaseFragment {

    @BindView(R.id.main_btn1)
    Button btn1;

    @BindView(R.id.main_btn2)
    Button btn2;

    @BindView(R.id.main_btn3)
    Button btn3;

    @BindView(R.id.main_btn4)
    Button btn4;

    @BindView(R.id.tv_Status1)
    TextView tv_Status1;

    @BindView(R.id.tv_Status2)
    TextView tv_Status2;

    @BindView(R.id.tv_Status3)
    TextView tv_Status3;

    @BindView(R.id.tv_Status4)
    TextView tv_Status4;

    @BindView(R.id.robot_topbar)
    QMUITopBarLayout mTopBar;//顶部标题

    RecyclerView material;

    private DialogView mDialogVisual;
    private DialogView mParSetVisual;


    @Override
    protected View onCreateView() {
        View root = LayoutInflater.from(getActivity()).inflate(R.layout.fragment_robot_main, null);
        ButterKnife.bind(this, root);
      return root;
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        OpenGoodSelectDialog();
        Init();

        String status = RobotModbus.getInstance().IsConnected?"已连接":"未连接";
        mTopBar.setTitle("机器人连接状态："+ status);

        RobotControl.getInstance().completeNotify= new ICompleteNotify() {
            @Override
            public void onComplete(int num) {
//                getActivity().runOnUiThread(new Runnable() {
//                    @Override
//                    public void run() {
//                        if (num==1)btn3.setVisibility(View.VISIBLE);
//                        else if (num==2)btn1.setVisibility(View.VISIBLE);
//                        else if (num==3)btn4.setVisibility(View.VISIBLE);
//                        else if (num==4)btn2.setVisibility(View.VISIBLE);
//                    }
//                });

                getActivity().runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        if (num==1){
                            btn3.setText("选择菜品");
                            btn3.setVisibility(View.VISIBLE);
                            btn3.setBackgroundResource(R.drawable.button4);
                            btn3.setTextColor(Color.parseColor("#000000"));
                        }
                        else if (num==2){
                            btn1.setText("选择菜品");
                            btn1.setVisibility(View.VISIBLE);
                            btn1.setBackgroundResource(R.drawable.button4);
                            btn1.setTextColor(Color.parseColor("#000000"));
                        }
                        else if (num==3){
                            btn4.setText("选择菜品");
                            btn4.setVisibility(View.VISIBLE);
                            btn4.setBackgroundResource(R.drawable.button4);
                            btn4.setTextColor(Color.parseColor("#000000"));
                        }
                        else if (num==4){
                            btn2.setText("选择菜品");
                            btn2.setVisibility(View.VISIBLE);
                            btn2.setBackgroundResource(R.drawable.button4);
                            btn2.setTextColor(Color.parseColor("#000000"));
                        }
                    }
                });
            }
        };

        RobotControl.getInstance().statusNotify=new IStatusNotify() {
            @Override
            public void OnStatusChanged(String s1, String s2, String s3, String s4) {
                getActivity().runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        tv_Status1.setText(s2);
                        tv_Status2.setText(s4);
                        tv_Status3.setText(s1);
                        tv_Status4.setText(s3);

                        String status = RobotModbus.getInstance().IsConnected?"已连接":"未连接";
                        mTopBar.setTitle("机器人连接状态："+ status);

                    }
                });
            }
        };


        mDialogVisual= DialogManager.getInstance().initView(getContext(), R.layout.activity_material_view, Gravity.BOTTOM,getActivity());
        mParSetVisual = DialogManager.getInstance().initView(getContext(),R.layout.activity_par_set,Gravity.BOTTOM,getActivity());
    }

    @SuppressLint("HandlerLeak")
    private Handler mHandler = new Handler() {
        @Override
        public void handleMessage(Message msg) {
            if (msg.obj.toString()== "MSG_REFRESH") {
                if(ConfigName.getInstance().cloudGoods!=null && ConfigName.getInstance().cloudGoods.size()>0)
                {
                    ArrayList<BPA_GOODS> goods= QueryDB.GetGoodsALL();
                    ArrayList<BPA_GOODSRECIPE> rec= QueryDB.GetGoodsSrecipeALL();
                    for (BPA_GOODS good:goods)
                    {
                        QueryDB.DeleteGoods(good);
                    }
                    for (BPA_GOODSRECIPE pf:rec)
                    {
                        QueryDB.DeleteGoodsSrecipe(pf);
                    }
                    for (CloudGood item : ConfigName.getInstance().cloudGoods) {
                        ConfigData.getInstance().GetGoodProcess(getContext(),item.id,false);
                    }
                }
                Log.i("info", "handleMessage: 获取商品信息成功");
            }
        }
    };

    private void Init(){
        Log.i("bpa", "Init: 开始获取云端数据");
        ConfigData.getInstance().GetOrganize(getContext());
        ConfigData.getInstance().GetGevGood(getContext(),mHandler);
    }

    private void OpenParSet(){
        //参数配置界面确认按钮
        ButtonClickBinder(mParSetVisual, R.id.parset_ok_btn,()->{
            Log.i("TAG", "onClick: 确认参数配置");

            if(!RobotModbus.getInstance().IsConnected){
                AlertDialogUtils.showDialog(getContext(),"提示","请先连接机器人");
                return;
            }
            RobotControl.getInstance(). GoodDown(fry.GoodID,fry.FryingPanNum);

            try {
//                Thread.sleep(4000);

                long startTime=System.currentTimeMillis();
                while(!RobotControl.getInstance().GetGoodVery(fry.FryingPanNum)&&(System.currentTimeMillis()-startTime)<=4000){
                    Thread.sleep(100);
                }

                if (RobotControl.getInstance().GetGoodVery(fry.FryingPanNum)){
                    if (fry.FryingPanNum==1) {
                        btn3.setText("强制取消");
                        btn3.setBackgroundResource(R.drawable.button5);
                        btn3.setTextColor(Color.parseColor("#ffffff"));
                    }
                    else if (fry.FryingPanNum==2){
                        btn1.setText("强制取消");
                        btn1.setBackgroundResource(R.drawable.button5);
                        btn1.setTextColor(Color.parseColor("#ffffff"));
                    }
                    else if (fry.FryingPanNum==3) {
                        btn4.setText("强制取消");
                        btn4.setBackgroundResource(R.drawable.button5);
                        btn4.setTextColor(Color.parseColor("#ffffff"));
                    }
                    else if (fry.FryingPanNum==4) {
                        btn2.setText("强制取消");
                        btn2.setBackgroundResource(R.drawable.button5);
                        btn2.setTextColor(Color.parseColor("#ffffff"));
                    }
                    RobotControl.getInstance().FryingPan.put(fry.FryingPanNum,fry);
                    fry=new FryingPanPar();
                    DialogManager.getInstance().hide(mParSetVisual);//关闭参数设置窗口
                }
                else{
                    AlertDialogUtils.showDialog(getContext(),"提示","商品验证失败");
                }
            }
            catch (InterruptedException e) {

            }

//            if (RobotControl.getInstance().GetGoodVery(fry.FryingPanNum)){
//                if (fry.FryingPanNum==1)btn3.setVisibility(View.GONE);
//                else if (fry.FryingPanNum==2)btn1.setVisibility(View.GONE);
//                else if (fry.FryingPanNum==3)btn4.setVisibility(View.GONE);
//                else if (fry.FryingPanNum==4)btn2.setVisibility(View.GONE);
//                RobotControl.getInstance().FryingPan.put(fry.FryingPanNum,fry);
//                fry=new FryingPanPar();
//                DialogManager.getInstance().hide(mParSetVisual);//关闭参数设置窗口
//            }
//            else{
//                AlertDialogUtils.showDialog(getContext(),"提示","商品验证失败");
//            }

        });

        //参数配置界面取消按钮
        ButtonClickBinder(mParSetVisual, R.id.parset_cancel_btn, ()->{
            Log.i("TAG", "onClick: 退出参数配置");
            fry=new FryingPanPar();
            DialogManager.getInstance().hide(mParSetVisual);//关闭参数设置窗口
        });

        DialogManager.getInstance().hide(mDialogVisual);//关闭商品选择窗口
        DialogManager.getInstance().show(mParSetVisual,R.id.parset_close_dialog); //打开参数设置窗口

        if (fry.FryingPanNum==1){
            ParSetInit(R.id.location_selection,new String[] { "1", "2", "3"});
        }else if (fry.FryingPanNum==2){
            ParSetInit(R.id.location_selection,new String[] { "4","5","6"});
        }else if (fry.FryingPanNum==3){
            ParSetInit(R.id.location_selection,new String[] { "4","5","6"});
        }else if (fry.FryingPanNum==4){
            ParSetInit(R.id.location_selection,new String[] { "1", "2", "3"});
        }

//        ParSetInit(R.id.location_selection,new String[] {"0", "1", "2", "3", "4","5","6"});
        ParSetInit(R.id.accessories_selection_1,new String[] {"0", "1", "2", "3", "4","5","6","7","8"});
        ParSetInit(R.id.accessories_selection_2,new String[] {"0", "1", "2", "3", "4","5","6","7","8"});
    }

    FryingPanPar fry=new FryingPanPar();

    private void OpenGoodSelectDialog()
    {
        MessageManager.getInstance().registerMessageReceiver(getActivity(), MessageName.ClickMakeGoodNew, new MessageLooper.OnMessageListener() {
            @Override
            public void onMessage(Object msg) {
                if (msg != null) {
                    BPA_GOODS goods = (BPA_GOODS) msg;
//                    OrderData.getInstance().goods=(BPA_GOODS) msg ;
                    fry.GoodID= goods.id;
                    OpenParSet();
                }
            }
        });

        btn1.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view){

                ProductSelectionButtonBinder(R.id.main_btn1,2);
//                if(btn1.getText().equals("强制取消"))
//                {
//                    AlertDialogUtils.showDialog(getContext(), "提示", "是否强制结束任务？", new QMUIDialogAction.ActionListener() {
//                        @Override
//                        public void onClick(QMUIDialog dialog, int index) {
//                            RobotControl.getInstance().SetForceEnd(2);
//                            btn1.setVisibility(View.GONE);
//                            dialog.dismiss();
//                        }
//                    });
//                }
//                else{
//                    fry.FryingPanNum=2;
//                    mDialogVisual.setCanceledOnTouchOutside(false);
//                    material=mDialogVisual.findViewById(R.id.rv_material);
//                    synchronous();
//                    LoadingGood();
//                    if(!getActivity().isFinishing())
//                        DialogManager.getInstance().show(mDialogVisual,R.id.close_dialog); //打开商品选择窗口
//                }


//                    fry.FryingPanNum=2;
//                    mDialogVisual.setCanceledOnTouchOutside(false);
//                    material=mDialogVisual.findViewById(R.id.rv_material);
//                    synchronous();
//                    LoadingGood();
//                    DialogManager.getInstance().show(mDialogVisual,R.id.close_dialog); //打开商品选择窗口
            }
        });

        btn2.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view){
                ProductSelectionButtonBinder(R.id.main_btn2,4);
//                if(btn2.getText().equals("强制取消"))
//                {
//                    AlertDialogUtils.showDialog(getContext(), "提示", "是否强制结束任务？", new QMUIDialogAction.ActionListener() {
//                        @Override
//                        public void onClick(QMUIDialog dialog, int index) {
//                            RobotControl.getInstance().SetForceEnd(4);
//                            btn2.setVisibility(View.GONE);
//                            dialog.dismiss();
//                        }
//                    });
//                }
//                else
//                {
//                    fry.FryingPanNum=4;
//                    mDialogVisual.setCanceledOnTouchOutside(false);
//                    material=mDialogVisual.findViewById(R.id.rv_material);
//                    synchronous();
//                    LoadingGood();
//                    if(!getActivity().isFinishing())
//                        DialogManager.getInstance().show(mDialogVisual,R.id.close_dialog); //打开商品选择窗口
//                }



//                if(RobotControl.getInstance().GetFryingPan(4)) {
//                    fry.FryingPanNum=4;
//                    mDialogVisual.setCanceledOnTouchOutside(false);
//                    material=mDialogVisual.findViewById(R.id.rv_material);
//                    synchronous();
//                    LoadingGood();
//                    DialogManager.getInstance().show(mDialogVisual,R.id.close_dialog); //打开商品选择窗口
//                }
//                else{
//                    AlertDialogUtils.showDialog(getContext(),"提示","炒锅状态异常");
//                }
            }
        });

        btn3.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view){

                ProductSelectionButtonBinder(R.id.main_btn3,1);

//                if(btn3.getText().equals("强制取消"))
//                {
//                    AlertDialogUtils.showDialog(getContext(), "提示", "是否强制结束任务？", new QMUIDialogAction.ActionListener() {
//                        @Override
//                        public void onClick(QMUIDialog dialog, int index) {
//                            RobotControl.getInstance().SetForceEnd(1);
//                            btn3.setVisibility(View.GONE);
//                            dialog.dismiss();
//                        }
//                    });
//                }
//                else
//                {
//                    fry.FryingPanNum=1;
//                    mDialogVisual.setCanceledOnTouchOutside(false);
//                    material=mDialogVisual.findViewById(R.id.rv_material);
//                    synchronous();
//                    LoadingGood();
//                    if(!getActivity().isFinishing())
//                        DialogManager.getInstance().show(mDialogVisual,R.id.close_dialog); //打开商品选择窗口
//                }


//                if(RobotControl.getInstance().GetFryingPan(2)){
//                    fry.FryingPanNum=1;
//                    mDialogVisual.setCanceledOnTouchOutside(false);
//                    material=mDialogVisual.findViewById(R.id.rv_material);
//                    synchronous();
//                    LoadingGood();
//                    DialogManager.getInstance().show(mDialogVisual,R.id.close_dialog); //打开商品选择窗口
//                }
//                else{
//                    AlertDialogUtils.showDialog(getContext(),"提示","炒锅状态异常");
//                }
            }
        });

        btn4.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view){

                ProductSelectionButtonBinder(R.id.main_btn4,3);

//                if(btn4.getText().equals("强制取消"))
//                {
//                    AlertDialogUtils.showDialog(getContext(), "提示", "是否强制结束任务？", new QMUIDialogAction.ActionListener() {
//                        @Override
//                        public void onClick(QMUIDialog dialog, int index) {
//                            DoubleFryingpanControl.getInstance().SetForceEnd(3);
//                            btn4.setVisibility(View.GONE);
//                            dialog.dismiss();
//                        }
//                    });
//                }
//                else
//                {
//                    fry.FryingPanNum=3;
//                    mDialogVisual.setCanceledOnTouchOutside(false);
//                    material=mDialogVisual.findViewById(R.id.rv_material);
//                    synchronous();
//                    LoadingGood();
//                    if(!getActivity().isFinishing())
//                        DialogManager.getInstance().show(mDialogVisual,R.id.close_dialog); //打开商品选择窗口
//                }


//                if(RobotControl.getInstance().GetFryingPan(3)){
//                    fry.FryingPanNum=3;
//                    mDialogVisual.setCanceledOnTouchOutside(false);
//                    material=mDialogVisual.findViewById(R.id.rv_material);
//                    synchronous();
//                    LoadingGood();
//                    DialogManager.getInstance().show(mDialogVisual,R.id.close_dialog); //打开商品选择窗口
//                }
//                else{
//                    AlertDialogUtils.showDialog(getContext(),"提示","炒锅状态异常");
//                }
            }
        });
    }

    /**
     * 同步商品
     */
    private void synchronous(){
        Button btn=mDialogVisual.findViewById(R.id.synchronous);
        btn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Init();
                LoadingGood();
            }
        });
    }

    /**
     * 加载商品
     */
    public void LoadingGood() {
        ArrayList<BPA_GOODS> goods= QueryDB.GetGoodsALL();
        ArrayList<BPA_GOODS> goodsm=new ArrayList<>();
        if (goods.size()>0){
            for (BPA_GOODS item:goods)goodsm.add(item);
        }else{
            for(CloudGood item: ConfigName.getInstance().cloudGoods){
                BPA_GOODS bpa=new BPA_GOODS();
                bpa.name=item.goods_Name;
                bpa.url=item.goods_ImgUrl;
                bpa.id=item.id;
                goodsm.add(bpa);
            }
        }
        List<LinkMode> Fdata = new ArrayList<>();
        Fdata.add(new LinkMode("main", Arrays.asList(goodsm.toArray()),true));
        MakeGoodRightAdapter rightAdapter = new MakeGoodRightAdapter(R.layout.item_right_lc, Fdata, getResources());
        material.setAdapter(rightAdapter);
    }

    private void ParSetInit(int id,String[] args)
    {
        Spinner sp = mParSetVisual.findViewById(id);
        ArrayAdapter<String> starAdapter = new ArrayAdapter<String>(getContext(), R.layout.select_item, args);
        sp.setAdapter(starAdapter);
        sp.setSelection(0);



        sp.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> adapterView, View view, int i, long l) {
                if(R.id.location_selection==id) {
                    fry.IngredientsLocs[0]=Integer.parseInt(adapterView.getItemAtPosition(i).toString());
                }
                else if  (R.id.accessories_selection_1==id) {
                    fry.AccessoriesLocs[0]=Integer.parseInt(adapterView.getItemAtPosition(i).toString());;
                }
                else if  (R.id.accessories_selection_2==id) {
                    fry.AccessoriesLocs[1]=Integer.parseInt(adapterView.getItemAtPosition(i).toString());;
                }
            }

            @Override
            public void onNothingSelected(AdapterView<?> adapterView) {

            }
        });
    }

    private void ProductSelectionButtonBinder(int id,int FiryNum){
        Button btn =getActivity().findViewById(id);
        if(btn.getText().equals("强制取消"))
        {
            AlertDialogUtils.showDialog(getContext(), "提示", "是否强制结束任务？", new QMUIDialogAction.ActionListener() {
                @Override
                public void onClick(QMUIDialog dialog, int index) {
                    DoubleFryingpanControl.getInstance().SetForceEnd(FiryNum);
                    btn.setVisibility(View.GONE);
                    dialog.dismiss();
                }
            });
        }
        else
        {
            fry.FryingPanNum=FiryNum;
            mDialogVisual.setCanceledOnTouchOutside(false);
            material=mDialogVisual.findViewById(R.id.rv_material);
            synchronous();
            LoadingGood();
            if(!getActivity().isFinishing())
                DialogManager.getInstance().show(mDialogVisual,R.id.close_dialog); //打开商品选择窗口
        }

    }

    /**
     * 弹框按钮事件绑定
     * @param dv 弹框页面
     * @param id 按钮id
     * @param action 执行委托
     */
    private void ButtonClickBinder(DialogView dv,int id, IRun action){
        if(dv!=null&& !dv.findViewById(id).hasOnClickListeners()){
            dv.findViewById(id).setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View view) {
                    if(action!=null) action.Run();
                }
            });
        }
    }

}
