package com.bonait.bnframework.modules.home.fragment.from;

import static com.bonait.bnframework.MainApplication.getContext;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.content.Context;
import android.content.DialogInterface;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.text.InputType;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.Spinner;

import com.bonait.bnframework.R;
import com.bonait.bnframework.business.ConfigData;
import com.bonait.bnframework.common.base.BaseActivity;
import com.bonait.bnframework.common.constant.ConfigName;
import com.bonait.bnframework.common.db.QueryDB;
import com.bonait.bnframework.common.db.mode.BPA_MATERIAL;
import com.bonait.bnframework.common.helper.I.MyClickListener;
import com.bonait.bnframework.common.helper.MessageLog;
import com.bonait.bnframework.common.utils.AlertDialogUtils;
import com.bonait.bnframework.common.utils.NetworkUtils;
import com.bonait.bnframework.common.utils.ToastUtils;
import com.bonait.bnframework.common.view.MyLayoutManager;
import com.bonait.bnframework.modules.home.adapter.devstatus_adapter;
import com.bonait.bnframework.modules.home.adapter.wl_adapter;
import com.qmuiteam.qmui.widget.QMUITopBarLayout;
import com.qmuiteam.qmui.widget.dialog.QMUIDialog;
import com.qmuiteam.qmui.widget.dialog.QMUIDialogAction;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.Map;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;

public class MaterialManangerActivity extends BaseActivity implements MyClickListener {

    @BindView(R.id.topbar)
    QMUITopBarLayout mTopBar;

    @BindView(R.id.edittext)
    EditText edittext;

    @BindView(R.id.wllx)
    Spinner wllx;

    @BindView(R.id.add_wl)
    Button add_wl;

    @BindView(R.id.datatab_wl)
    ListView datatab_wl;

    Map<String, Integer> wllx_map = new LinkedHashMap<>();
    /**
     * 物料数据
     */
    ArrayList<BPA_MATERIAL> bpa_materials = new ArrayList<>();
    private Context context;
    Activity activity=null;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_materialmananger);
        ButterKnife.bind(this);
        context=getContext();
        activity=this;
        initTopBar();
//        initFragment();
        wllx_map.put("液料", 0);
        wllx_map.put("酱料", 1);
        ArrayAdapter<String> adapter2 = new ArrayAdapter<>(activity, R.layout.spinner_text_item, new ArrayList<>(wllx_map.keySet()));
        adapter2.setDropDownViewResource(R.layout.spinner_dropdown_item);
        wllx.setAdapter(adapter2);
        Initdata_wl();
    }

    private void initTopBar() {
        mTopBar.setTitle("实时监控管理");
        mTopBar.addLeftImageButton(R.mipmap.fanhui,R.id.topbar).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                finish();
            }
        });
    }
    public devstatus_adapter adapter=null;

    /**
     * 初始化数据加载
     */
    public void Initdata_wl() {
        try {
            bpa_materials = QueryDB.GetMaterialALL();
            wl_adapter adapter = new wl_adapter(activity, R.layout.wl_item, bpa_materials, this);
            datatab_wl.setAdapter(adapter);
        } catch (Exception e) {

        }
    }

    @SuppressLint("HandlerLeak")
    private Handler mHandler = new Handler() {
        @Override
        public void handleMessage(Message msg) {
            if (msg.obj.toString()== "MSG_REFRESH") {
                Initdata_wl();
            }
        }
    };
    @OnClick({R.id.add_wl, R.id.synchronous})
    public void onViewClicked(View view) {
        switch (view.getId()) {
            case R.id.add_wl://增加物料
                String name = edittext.getText().toString();
                String lx = wllx.getSelectedItem().toString();
                if (name.isEmpty()) {
                    ToastUtils.info("物料名称不能为空");
                    return;
                }
                if (lx.isEmpty()) {
                    ToastUtils.info("物料类型不能为空");
                    return;
                }
                if (QueryDB.GetMaterialIs(name)) {
                    ToastUtils.info("物料名称重复,请重新输入后重试!");
                    return;
                }
                BPA_MATERIAL bpa_material = new BPA_MATERIAL();
                bpa_material.name = name;
                bpa_material.imgUrl = "";
                bpa_material.type = wllx_map.get(lx);
                bpa_material.deviceID = ConfigName.getInstance().DeviceId;
                bpa_material.userID = ConfigName.getInstance().user.userID;
                QueryDB.AddMaterial(bpa_material);
                ToastUtils.info("新增成功");
                Initdata_wl();
                break;
            case R.id.synchronous://同步云端

                if (NetworkUtils.checkNetworkAvailable(activity)) {
                    final QMUIDialog.EditTextDialogBuilder builder = new QMUIDialog.EditTextDialogBuilder(activity);
                    builder.setTitle("密码确认")
                            .setPlaceholder("在此输入权限密码")
                            .setInputType(InputType.TYPE_CLASS_TEXT)

                            .setCanceledOnTouchOutside(false)
                            .addAction("取消", new QMUIDialogAction.ActionListener() {
                                @Override
                                public void onClick(QMUIDialog dialog, int index) {
                                    dialog.dismiss();
                                }
                            })
                            .addAction("确定", new QMUIDialogAction.ActionListener() {
                                @Override
                                public void onClick(QMUIDialog dialog, int index) {
                                    CharSequence text = builder.getEditText().getText();
                                    if (text != null && text.length() > 0) {
                                        if (text.toString().equals(ConfigName.getInstance().user.pass)) {
                                            ConfigData.getInstance().SyncDataInTheCloud(activity,mHandler);
                                            dialog.dismiss();
                                        } else {
                                            ToastUtils.info("权限密码不正确！");
                                        }
                                    } else {
                                        ToastUtils.info("权限密码不正确！");
                                    }
                                }
                            })
                            .create(AlertDialogUtils.mCurrentDialogStyle).show();
                } else {
                    ToastUtils.warning("无网络,请先连接网络!!!");
                }
                break;
        }
    }


    /**
     * viewPager里添加fragment
     */
    private void initFragment() {
        MyLayoutManager layout = new MyLayoutManager();
        layout.setAutoMeasureEnabled(true);
        adapter = new devstatus_adapter(getContext(),this);
    }
    //-------------------------配置viewPager与fragment关联----------------------------//

    @Override
    public void onDestroy() {
        super.onDestroy();
    }

    @Override
    protected boolean canDragBack() {
        return false;
    }

    @Override
    public void clickListener(View v, Object data) {
        switch (v.getId()) {
            case R.id.name://修改物料名称按钮
                final QMUIDialog.EditTextDialogBuilder builder = new QMUIDialog.EditTextDialogBuilder(activity);
                builder.setTitle("物料名称")
                        .setPlaceholder("在此输入物料名称")
                        .setDefaultText(((BPA_MATERIAL) data).name)
                        .setInputType(InputType.TYPE_CLASS_TEXT)
                        .setCanceledOnTouchOutside(false)
                        .addAction("取消", new QMUIDialogAction.ActionListener() {
                            @Override
                            public void onClick(QMUIDialog dialog, int index) {
                                dialog.dismiss();
                            }
                        })
                        .addAction("确定", new QMUIDialogAction.ActionListener() {
                            @Override
                            public void onClick(QMUIDialog dialog, int index) {
                                CharSequence text = builder.getEditText().getText();
                                if (text != null && text.length() > 0) {
                                    if (QueryDB.GetMaterialIs(text.toString())) {
                                        ToastUtils.info("物料名称重复,请重新输入后重试!");
                                        return;
                                    }
                                    QueryDB.UpdateMaterialName(((BPA_MATERIAL) data).id, text.toString());
                                    Initdata_wl();
                                    dialog.dismiss();
                                } else {
                                    //请填入昵称
                                    ToastUtils.info("物料名称不能为空！");
                                }
                            }
                        })
                        .create(AlertDialogUtils.mCurrentDialogStyle).show();
                break;
            case R.id.lx://选择类型
                final String[] items = new String[]{"液料", "酱料"};
                final int checkIndex = ((BPA_MATERIAL) data).type;
                try{
                    new QMUIDialog.CheckableDialogBuilder(activity)
                            .addItems(items, new DialogInterface.OnClickListener() {
                                @Override
                                public void onClick(DialogInterface dialog, int which) {
                                    QueryDB.UpdateMaterialType(((BPA_MATERIAL) data).id, which);
                                    Initdata_wl();
                                    dialog.dismiss();
                                }
                            })
                            .setCheckedIndex(checkIndex)
                            .show();
                }catch (Exception e){
                    MessageLog.ShowInfo("打开弹框出错："+e.getMessage());
                }

                break;
            case R.id.button_item://删除按钮
                QueryDB.DeleteMaterial((BPA_MATERIAL) data);
                Initdata_wl();
                break;
        }
    }

    @Override
    public void clickListenerNew(View v, int k, Object data) {

    }
}